// {{{RME classifier 'Logical View::VCNS_TopCapsule'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "VCNS_TopCapsule.h"
#endif

#include <RTSystem/VCNS.h>
#include <VCNS_TopCapsule.h>
#include <P_ECRM.h>
#include <P_SUII.h>
#include <P_VBAD.h>
extern const RTActorClass cap_ECRM_ECOM;
extern const RTActorClass cap_SUII_VCOMSAT;
extern const RTActorClass cap_VBAD;
extern const RTActorClass cap_VCOM;
extern const RTActorClass cap_VNAV;
extern const RTActorClass cap_VVIG;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static RTActor * new_VCNS_TopCapsule_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new VCNS_TopCapsule_Actor( _rts, _ref );
}

const RTActorClass VCNS_TopCapsule =
{
	(const RTActorClass *)0
  , "VCNS_TopCapsule"
  , (RTVersionId)0
  , 0
  , (const RTRelayDescriptor *)0
  , new_VCNS_TopCapsule_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
};

static const RTInterfaceDescriptor rtg_interfaces_cap_ECRM_ECOMR1[] =
{
	{
		"ECRM"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_cap_ECRM_ECOMR1[] =
{
	{
		0
	  , &P_ECRM::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_cap_SUII_VCOMSATR1[] =
{
	{
		"SUII"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_cap_SUII_VCOMSATR1[] =
{
	{
		0
	  , &P_SUII::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_cap_VBADR1[] =
{
	{
		"VCOM"
	  , 1
	}
  , {
		"VNAV"
	  , 1
	}
  , {
		"VVIG"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_cap_VBADR1[] =
{
	{
		0
	  , &P_VBAD::Base::rt_class
	}
  , {
		1
	  , &P_VBAD::Base::rt_class
	}
  , {
		2
	  , &P_VBAD::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_cap_VCOMR1[] =
{
	{
		"VCOM_VBAD"
	  , 1
	}
  , {
		"VCOM_ECRM"
	  , 1
	}
  , {
		"VCOM_SUII"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_cap_VCOMR1[] =
{
	{
		0
	  , &P_VBAD::Conjugate::rt_class
	}
  , {
		1
	  , &P_ECRM::Conjugate::rt_class
	}
  , {
		2
	  , &P_SUII::Conjugate::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_cap_VNAVR1[] =
{
	{
		"VNAV_VBAD"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_cap_VNAVR1[] =
{
	{
		0
	  , &P_VBAD::Conjugate::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_cap_VVIGR1[] =
{
	{
		"VVIG_VBAD"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_cap_VVIGR1[] =
{
	{
		0
	  , &P_VBAD::Conjugate::rt_class
	}
};

#define SUPER RTActor

VCNS_TopCapsule_Actor::VCNS_TopCapsule_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

VCNS_TopCapsule_Actor::~VCNS_TopCapsule_Actor( void )
{
}

int VCNS_TopCapsule_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// cap_ECRM_ECOMR1
		switch( rtg_portId )
		{
		case 0:
			// ECRM
			if( rtg_repIndex < 1 )
			{
				// cap_VCOMR1/VCOM_ECRM
				return cap_VCOMR1._followIn( rtg_end, 1, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 2:
		// cap_SUII_VCOMSATR1
		switch( rtg_portId )
		{
		case 0:
			// SUII
			if( rtg_repIndex < 1 )
			{
				// cap_VCOMR1/VCOM_SUII
				return cap_VCOMR1._followIn( rtg_end, 2, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 3:
		// cap_VBADR1
		switch( rtg_portId )
		{
		case 0:
			// VCOM
			if( rtg_repIndex < 1 )
			{
				// cap_VCOMR1/VCOM_VBAD
				return cap_VCOMR1._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 1:
			// VNAV
			if( rtg_repIndex < 1 )
			{
				// cap_VNAVR1/VNAV_VBAD
				return cap_VNAVR1._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 2:
			// VVIG
			if( rtg_repIndex < 1 )
			{
				// cap_VVIGR1/VVIG_VBAD
				return cap_VVIGR1._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 4:
		// cap_VCOMR1
		switch( rtg_portId )
		{
		case 0:
			// VCOM_VBAD
			if( rtg_repIndex < 1 )
			{
				// cap_VBADR1/VCOM
				return cap_VBADR1._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 1:
			// VCOM_ECRM
			if( rtg_repIndex < 1 )
			{
				// cap_ECRM_ECOMR1/ECRM
				return cap_ECRM_ECOMR1._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		case 2:
			// VCOM_SUII
			if( rtg_repIndex < 1 )
			{
				// cap_SUII_VCOMSATR1/SUII
				return cap_SUII_VCOMSATR1._followIn( rtg_end, 0, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 5:
		// cap_VNAVR1
		switch( rtg_portId )
		{
		case 0:
			// VNAV_VBAD
			if( rtg_repIndex < 1 )
			{
				// cap_VBADR1/VNAV
				return cap_VBADR1._followIn( rtg_end, 1, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 6:
		// cap_VVIGR1
		switch( rtg_portId )
		{
		case 0:
			// VVIG_VBAD
			if( rtg_repIndex < 1 )
			{
				// cap_VBADR1/VVIG
				return cap_VBADR1._followIn( rtg_end, 2, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RTActor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

void VCNS_TopCapsule_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * VCNS_TopCapsule_Actor::getActorData( void ) const
{
	return &VCNS_TopCapsule_Actor::rtg_class;
}

const RTActor_class VCNS_TopCapsule_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 1
  , VCNS_TopCapsule_Actor::rtg_parent_state
  , &VCNS_TopCapsule
  , 6
  , VCNS_TopCapsule_Actor::rtg_capsule_roles
  , 0
  , (const RTPortDescriptor *)0
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId VCNS_TopCapsule_Actor::rtg_parent_state[] =
{
	0
};

const RTComponentDescriptor VCNS_TopCapsule_Actor::rtg_capsule_roles[] =
{
	{
		"cap_ECRM_ECOMR1"
	  , &cap_ECRM_ECOM
	  , RTOffsetOf( VCNS_TopCapsule_Actor, cap_ECRM_ECOMR1 )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_cap_ECRM_ECOMR1
	  , 1
	  , rtg_bindings_cap_ECRM_ECOMR1
	}
  , {
		"cap_SUII_VCOMSATR1"
	  , &cap_SUII_VCOMSAT
	  , RTOffsetOf( VCNS_TopCapsule_Actor, cap_SUII_VCOMSATR1 )
	  , 2
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_cap_SUII_VCOMSATR1
	  , 1
	  , rtg_bindings_cap_SUII_VCOMSATR1
	}
  , {
		"cap_VBADR1"
	  , &cap_VBAD
	  , RTOffsetOf( VCNS_TopCapsule_Actor, cap_VBADR1 )
	  , 3
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 3
	  , rtg_interfaces_cap_VBADR1
	  , 3
	  , rtg_bindings_cap_VBADR1
	}
  , {
		"cap_VCOMR1"
	  , &cap_VCOM
	  , RTOffsetOf( VCNS_TopCapsule_Actor, cap_VCOMR1 )
	  , 4
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 3
	  , rtg_interfaces_cap_VCOMR1
	  , 3
	  , rtg_bindings_cap_VCOMR1
	}
  , {
		"cap_VNAVR1"
	  , &cap_VNAV
	  , RTOffsetOf( VCNS_TopCapsule_Actor, cap_VNAVR1 )
	  , 5
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_cap_VNAVR1
	  , 1
	  , rtg_bindings_cap_VNAVR1
	}
  , {
		"cap_VVIGR1"
	  , &cap_VVIG
	  , RTOffsetOf( VCNS_TopCapsule_Actor, cap_VVIGR1 )
	  , 6
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_cap_VVIGR1
	  , 1
	  , rtg_bindings_cap_VVIGR1
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
