// {{{RME classifier 'Logical View::VVIG::Image_Controller'

#ifndef Image_Controller_H
#define Image_Controller_H

#ifdef PRAGMA
#pragma interface "Image_Controller.h"
#endif

#include <RTSystem/VVIG.h>
#include <Image_Classifier_Protocol.h>
#include <Image_Device_Protocol.h>
#include <Image_Processor_Protocol.h>
#include <P_VBAD.h>

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR

// }}}USR
// }}}RME

extern const RTActorClass Image_Controller;

#define SUPER RTActor
class Image_Controller_Actor : public RTActor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME port 'to_intbus'
	P_VBAD::Conjugate to_intbus;
	// }}}RME
	// {{{RME port 'to_Image_Device'
	Image_Device_Protocol::Base to_Image_Device;
	// }}}RME
	// {{{RME port 'to_Image_Processor'
	Image_Processor_Protocol::Base to_Image_Processor;
	// }}}RME
	// {{{RME port 'to_Image_Classifier'
	Image_Classifier_Protocol::Base to_Image_Classifier;
	// }}}RME

public:
	Image_Controller_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~Image_Controller_Actor( void );
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME enter ':TOP:Image_Capture'
	INLINE_METHODS void enter3_Image_Capture( void );
	// }}}RME
	virtual void enterStateV( void );
	// {{{RME enter ':TOP:Image_Process'
	INLINE_METHODS void enter4_Image_Process( void );
	// }}}RME
	// {{{RME enter ':TOP:Image_Classify'
	INLINE_METHODS void enter5_Image_Classify( void );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain2_to_Capture( void );
	INLINE_CHAINS void chain3_to_Process( void );
	INLINE_CHAINS void chain4_To_Classification( void );
	INLINE_CHAINS void chain5_Wait( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* Image_Controller_H */

// }}}RME
