// {{{RME classifier 'Logical View::VVIG::Image_Device_Protocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Image_Device_Protocol.h"
#endif

#include <RTSystem/VVIG.h>
#include <Image_Device_Protocol.h>

const RTProtocolDescriptor Image_Device_Protocol::Base::rt_class =
{
	&RTRootProtocol::rt_class
  , &Image_Device_Protocol::Conjugate::rt_class
  , "Image_Device_Protocol"
  , 0
  , 3
  , Image_Device_Protocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Image_Device_Protocol::Base::rt_signals[] =
{
	{
		"photo_ready"
	  , &RTType_void
	  , Image_Device_Protocol::Base::rti_photo_ready
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , Image_Device_Protocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Image_Device_Protocol::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor Image_Device_Protocol::Conjugate::rt_class =
{
	&RTRootProtocol::rt_class
  , &Image_Device_Protocol::Base::rt_class
  , "Image_Device_Protocol"
  , 0
  , 3
  , Image_Device_Protocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor Image_Device_Protocol::Conjugate::rt_signals[] =
{
	{
		"rtBound"
	  , (const RTObject_class *)0
	  , Image_Device_Protocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , Image_Device_Protocol::Conjugate::rti_rtUnbound
	}
  , {
		"take_photo"
	  , &RTType_void
	  , Image_Device_Protocol::Conjugate::rti_take_photo
	}
};

// }}}RME
