// {{{RME classifier 'Logical View::VVIG::Image_Processor_Protocol'

#ifndef Image_Processor_Protocol_H
#define Image_Processor_Protocol_H

#ifdef PRAGMA
#pragma interface "Image_Processor_Protocol.h"
#endif

#include <RTSystem/VVIG.h>

struct Image_Processor_Protocol
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum { rti_Image_Processed = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_Image_Processor_Protocol = rti_Image_Processed };

	public:
		inline RTInSignal Image_Processed( void );
		inline RTOutSignal Process_Image( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum { rti_Process_Image = rtiLast_RTRootProtocol + 1 };

	protected:
		enum { rtiLast_Image_Processor_Protocol = rti_Process_Image };

	public:
		inline RTInSignal Process_Image( void );
		inline RTOutSignal Image_Processed( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline Image_Processor_Protocol::Base::Base( void )
	: RTRootProtocol()
{
}

inline Image_Processor_Protocol::Base::~Base( void )
{
}

inline RTInSignal Image_Processor_Protocol::Base::Image_Processed( void )
{
	return RTInSignal( this, rti_Image_Processed );
}

inline RTOutSignal Image_Processor_Protocol::Base::Process_Image( void )
{
	return RTOutSignal( this, Conjugate::rti_Process_Image, (const void *)0, &RTType_void );
}

inline Image_Processor_Protocol::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline Image_Processor_Protocol::Conjugate::~Conjugate( void )
{
}

inline RTInSignal Image_Processor_Protocol::Conjugate::Process_Image( void )
{
	return RTInSignal( this, rti_Process_Image );
}

inline RTOutSignal Image_Processor_Protocol::Conjugate::Image_Processed( void )
{
	return RTOutSignal( this, Base::rti_Image_Processed, (const void *)0, &RTType_void );
}

#endif /* Image_Processor_Protocol_H */

// }}}RME
