// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness'

#ifndef RQARTAbstractTestHarness_H
#define RQARTAbstractTestHarness_H

#ifdef PRAGMA
#pragma interface "RQARTAbstractTestHarness.h"
#endif

#include <RTSystem/VVIG.h>
#include <RQARTAbstractTestBase.h>
#include <RQARTAddInProtocol.h>
#include <RQARTExceptionCode.h>
class RQARTIncarnateArguments;
class RQARTStartTestNData;

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR

// }}}USR
// }}}RME

extern const RTActorClass RQARTAbstractTestHarness;

#define SUPER RQARTAbstractTestBase_Actor
class RQARTAbstractTestHarness_Actor : public RQARTAbstractTestBase_Actor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME classAttribute 'timeoutTid'
	RTTimerId timeoutTid;
	// }}}RME
	// {{{RME classAttribute 'nCompletedDrivers'
	int nCompletedDrivers;
	// }}}RME
	// {{{RME classAttribute 'nNumDrivers'
	int * nNumDrivers;
	// }}}RME
	// {{{RME classAttribute 'nMaxTime'
	int nMaxTime;
	// }}}RME
	// {{{RME classAttribute 'nCurrentTest'
	int nCurrentTest;
	// }}}RME
	// {{{RME classAttribute 'nTimerCount'
	int nTimerCount;
	// }}}RME
	// {{{RME classAttribute 'nMinRunTimes'
	int * nMinRunTimes;
	// }}}RME
	// {{{RME classAttribute 'nMaxInstances'
	int nMaxInstances;
	// }}}RME
	// {{{RME classAttribute 'nCurrentInstances'
	int nCurrentInstances;
	// }}}RME
	// {{{RME classAttribute 'nEnvironmentIndex'
	int nEnvironmentIndex;
	// }}}RME
	// {{{RME classAttribute 'nRQARTControllerVersion'
	int nRQARTControllerVersion;
	// }}}RME
	// {{{RME capsuleRole 'RQART_TCPServer'
	RTActorRef RQART_TCPServer;
	// }}}RME
	// {{{RME port 'RQART_Timer'
	Timing::Base RQART_Timer;
	// }}}RME
	// {{{RME port 'addIn'
	RQARTAddInProtocol::Base addIn;
	// }}}RME

public:
	RQARTAbstractTestHarness_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~RQARTAbstractTestHarness_Actor( void );

protected:
	// {{{RME operation 'StartTimeoutTimer()'
	virtual void StartTimeoutTimer( void );
	// }}}RME
	// {{{RME operation 'CancelTimeoutTimer()'
	virtual void CancelTimeoutTimer( void );
	// }}}RME
	// {{{RME operation 'PrepareToStartTest(const int *const)'
	virtual void PrepareToStartTest( const int * const minRunTimes );
	// }}}RME
	// {{{RME operation 'CompleteTest()'
	virtual void CompleteTest( void );
	// }}}RME
	// {{{RME operation 'DestroyDrivers()'
	virtual void DestroyDrivers( void );
	// }}}RME
	// {{{RME operation 'DestroyCUTs()'
	virtual void DestroyCUTs( void );
	// }}}RME
	// {{{RME operation 'Reset()'
	virtual void Reset( void );
	// }}}RME
	// {{{RME operation 'CreateCapsuleRoleIfNecessary(RTActorRef &,const RQARTIncarnateArguments *)'
	virtual bool CreateCapsuleRoleIfNecessary( RTActorRef & capsuleRole, const RQARTIncarnateArguments * args );
	// }}}RME
	// {{{RME operation 'StartMinRunTimeTimer(int)'
	virtual void StartMinRunTimeTimer( int nInstanceIndex );
	// }}}RME
	// {{{RME operation 'CleanUpTest()'
	virtual void CleanUpTest( void );
	// }}}RME
	// {{{RME operation 'InitializeTest(const int *const)'
	virtual void InitializeTest( const int * const minRunTimes );
	// }}}RME
	// {{{RME operation 'ZeroMinRunTimes()'
	void ZeroMinRunTimes( void );
	// }}}RME
	// {{{RME operation 'DestructorHelper()'
	void DestructorHelper( void );
	// }}}RME

public:
	virtual int _followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME enter ':TOP:Failed'
	INLINE_METHODS void enter5_Failed( void );
	// }}}RME
	virtual void enterStateV( void );
	// {{{RME transition ':TOP:Junction1:timeout' guard '1'
	INLINE_METHODS int guard2_timeout_event1( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Junction1:timeout'
	INLINE_METHODS void transition2_timeout( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Ready:Junction2:Reset'
	INLINE_METHODS void transition3_Reset( const void * rtdata, RQARTAddInProtocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Ready:Junction5:SetMaxTime'
	INLINE_METHODS void transition4_SetMaxTime( const int * rtdata, RQARTAddInProtocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:RunningTest:Junction4:timerCompleted' guard '1'
	INLINE_METHODS int guard5_timerCompleted_event1( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:RunningTest:Junction4:timerCompleted'
	INLINE_METHODS void transition5_timerCompleted( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Junction2:timerCompleted' guard '1'
	INLINE_METHODS int guard6_timerCompleted_event1( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Junction2:timerCompleted'
	INLINE_METHODS void transition6_timerCompleted( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:WaitingForCleanUp:Junction2:cleanUp'
	INLINE_METHODS void transition7_cleanUp( const void * rtdata, RQARTAddInProtocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Ready:Junction8:StartTest'
	INLINE_METHODS void transition8_StartTest( const void * rtdata, RQARTAddInProtocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:RunningTest:Junction1:DriverCompleted'
	INLINE_METHODS void transition9_DriverCompleted( const void * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:AreAllDriversCompleted:True'
	INLINE_METHODS void transition11_True( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Junction4:errorException'
	INLINE_METHODS void transition12_errorException( const void * rtdata, Exception::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Junction5:DriverFailed'
	INLINE_METHODS void transition13_DriverFailed( const void * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Ready:Junction9:SetControllerVersion'
	INLINE_METHODS void transition14_SetControllerVersion( const int * rtdata, RQARTAddInProtocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Failed:Junction7:ignoreMessages'
	INLINE_METHODS void transition15_ignoreMessages( const void * rtdata, RTProtocol * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain12_errorException( void );
	INLINE_CHAINS void chain2_timeout( void );
	INLINE_CHAINS void chain6_timerCompleted( void );
	INLINE_CHAINS void chain8_StartTest( void );
	INLINE_CHAINS void chain3_Reset( void );
	INLINE_CHAINS void chain4_SetMaxTime( void );
	INLINE_CHAINS void chain14_SetControllerVersion( void );
	INLINE_CHAINS void chain7_cleanUp( void );
	INLINE_CHAINS void chain5_timerCompleted( void );

protected:
	// {{{RME choicePoint ':TOP:AreAllDriversCompleted'
	INLINE_METHODS int choicePoint1_AreAllDriversCompleted( const void * rtdata, Timing::Base * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain11_True( void );
	INLINE_CHAINS void chain10_False( void );
	INLINE_CHAINS void chain15_ignoreMessages( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTComponentDescriptor rtg_capsule_roles[];
	static const RTPortDescriptor rtg_ports[];

public:
	static const RTFieldDescriptor rtg_RQARTAbstractTestHarness_fields[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* RQARTAbstractTestHarness_H */

// }}}RME
