// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper'

#ifndef RQARTAbstractTestWrapper_H
#define RQARTAbstractTestWrapper_H

#ifdef PRAGMA
#pragma interface "RQARTAbstractTestWrapper.h"
#endif

#include <RTSystem/VVIG.h>
#include <RQARTAbstractTestBase.h>
#include <RQARTTestDriverProtocol.h>
enum RQARTExceptionCode;
class RQARTStartTestNData;

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR

// }}}USR
// }}}RME

extern const RTActorClass RQARTAbstractTestWrapper;

#define SUPER RQARTAbstractTestBase_Actor
class RQARTAbstractTestWrapper_Actor : public RQARTAbstractTestBase_Actor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME classAttribute 'nCoregionMsgs'
	int nCoregionMsgs;
	// }}}RME
	// {{{RME classAttribute 'bMinRunTimeCompleted'
	bool bMinRunTimeCompleted;
	// }}}RME
	// {{{RME classAttribute 'nInstanceIndex'
	int nInstanceIndex;
	// }}}RME
	// {{{RME classAttribute 'nCurrentMessageIndex'
	int nCurrentMessageIndex;
	// }}}RME
	// {{{RME port 'RQART_TestHarness'
	RQARTTestDriverProtocol::Conjugate RQART_TestHarness;
	// }}}RME
	// {{{RME port 'RQART_Timer'
	Timing::Base RQART_Timer;
	// }}}RME

public:
	RQARTAbstractTestWrapper_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~RQARTAbstractTestWrapper_Actor( void );

protected:
	// {{{RME operation 'StartMinRunTimeTimer(int)'
	virtual void StartMinRunTimeTimer( int nSeconds );
	// }}}RME
	// {{{RME operation 'SendACompareFailure(const char *const)'
	void SendACompareFailure( const char * const pMsg );
	// }}}RME
	// {{{RME operation 'LogAMessage(const char *const)'
	void LogAMessage( const char * const pMsg );
	// }}}RME

public:
	virtual int _followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:Junction1:errorException'
	INLINE_METHODS void transition1_errorException( const void * rtdata, Exception::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Junction2:minRunTimeCompleted'
	INLINE_METHODS void transition3_minRunTimeCompleted( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:WaitingForTimer:Junction3:minRunTimeCompleted'
	INLINE_METHODS void transition5_minRunTimeCompleted( const void * rtdata, Timing::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:IsMinRunTimeComplete:True'
	INLINE_METHODS void transition6_True( const void * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:Junction4:ignoreStartTestN'
	INLINE_METHODS void transition7_ignoreStartTestN( const RQARTStartTestNData * rtdata, RQARTTestDriverProtocol::Conjugate * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain2_Initial( void );
	INLINE_CHAINS void chain1_errorException( void );
	INLINE_CHAINS void chain7_ignoreStartTestN( void );
	INLINE_CHAINS void chain3_minRunTimeCompleted( void );
	INLINE_CHAINS void chain8_ignoreMessages( void );
	INLINE_CHAINS void chain5_minRunTimeCompleted( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );

protected:
	// {{{RME choicePoint ':TOP:IsMinRunTimeComplete'
	INLINE_METHODS int choicePoint1_IsMinRunTimeComplete( const void * rtdata, RTProtocol * rtport );
	// }}}RME

public:
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTPortDescriptor rtg_ports[];

public:
	static const RTFieldDescriptor rtg_RQARTAbstractTestWrapper_fields[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* RQARTAbstractTestWrapper_H */

// }}}RME
