// {{{RME classifier 'Logical View::RQART_TestRun_VVIG::RQARTStructureProtocol'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "RQARTStructureProtocol.h"
#endif

#include <RTSystem/VVIG.h>
#include <RQARTStructureProtocol.h>

const RTProtocolDescriptor RQARTStructureProtocol::Base::rt_class =
{
	&RQARTTestDriverProtocol::Base::rt_class
  , &RQARTStructureProtocol::Conjugate::rt_class
  , "RQARTStructureProtocol"
  , 0
  , 14
  , RQARTStructureProtocol::Base::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor RQARTStructureProtocol::Base::rt_signals[] =
{
	{
		"CompareFailure"
	  , &RTType_RTString
	  , RQARTStructureProtocol::Base::rti_CompareFailure
	}
  , {
		"Destroy_image_Classifier"
	  , &RTType_int
	  , RQARTStructureProtocol::Base::rti_Destroy_image_Classifier
	}
  , {
		"Destroy_image_Controller"
	  , &RTType_int
	  , RQARTStructureProtocol::Base::rti_Destroy_image_Controller
	}
  , {
		"Destroy_image_Device"
	  , &RTType_int
	  , RQARTStructureProtocol::Base::rti_Destroy_image_Device
	}
  , {
		"Destroy_image_Processor"
	  , &RTType_int
	  , RQARTStructureProtocol::Base::rti_Destroy_image_Processor
	}
  , {
		"DriverCompleted"
	  , &RTType_void
	  , RQARTStructureProtocol::Base::rti_DriverCompleted
	}
  , {
		"DriverFailed"
	  , &RTType_RQARTExceptionCode
	  , RQARTStructureProtocol::Base::rti_DriverFailed
	}
  , {
		"Incarnate_image_Classifier"
	  , (const RTObject_class *)0
	  , RQARTStructureProtocol::Base::rti_Incarnate_image_Classifier
	}
  , {
		"Incarnate_image_Controller"
	  , (const RTObject_class *)0
	  , RQARTStructureProtocol::Base::rti_Incarnate_image_Controller
	}
  , {
		"Incarnate_image_Device"
	  , (const RTObject_class *)0
	  , RQARTStructureProtocol::Base::rti_Incarnate_image_Device
	}
  , {
		"Incarnate_image_Processor"
	  , (const RTObject_class *)0
	  , RQARTStructureProtocol::Base::rti_Incarnate_image_Processor
	}
  , {
		"LogMessage"
	  , &RTType_RTString
	  , RQARTStructureProtocol::Base::rti_LogMessage
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , RQARTStructureProtocol::Base::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , RQARTStructureProtocol::Base::rti_rtUnbound
	}
};

const RTProtocolDescriptor RQARTStructureProtocol::Conjugate::rt_class =
{
	&RQARTTestDriverProtocol::Conjugate::rt_class
  , &RQARTStructureProtocol::Base::rt_class
  , "RQARTStructureProtocol"
  , 0
  , 5
  , RQARTStructureProtocol::Conjugate::rt_signals
#if RTRUNTIMEBC
  , &RTProtocolDescriptor::getUnknownGlobalSignal, &RTProtocolDescriptor::getUnknownLocalSignal
#endif
};

const RTSignalDescriptor RQARTStructureProtocol::Conjugate::rt_signals[] =
{
	{
		"FrameFAIL"
	  , &RTType_void
	  , RQARTStructureProtocol::Conjugate::rti_FrameFAIL
	}
  , {
		"FrameOK"
	  , &RTType_void
	  , RQARTStructureProtocol::Conjugate::rti_FrameOK
	}
  , {
		"StartTestN"
	  , &RTType_RQARTStartTestNData
	  , RQARTStructureProtocol::Conjugate::rti_StartTestN
	}
  , {
		"rtBound"
	  , (const RTObject_class *)0
	  , RQARTStructureProtocol::Conjugate::rti_rtBound
	}
  , {
		"rtUnbound"
	  , (const RTObject_class *)0
	  , RQARTStructureProtocol::Conjugate::rti_rtUnbound
	}
};

// }}}RME
