// {{{RME classifier 'Logical View::RQART_TestRun_VVIG::RQARTStructureProtocol'

#ifndef RQARTStructureProtocol_H
#define RQARTStructureProtocol_H

#ifdef PRAGMA
#pragma interface "RQARTStructureProtocol.h"
#endif

#include <RTSystem/VVIG.h>
#include <RQARTTestDriverProtocol.h>

struct RQARTStructureProtocol
{
	class Base : public RQARTTestDriverProtocol::Base
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum
		{
			rti_Incarnate_image_Controller = rtiLast_RQARTTestDriverProtocol + 1
		  , rti_Destroy_image_Controller
		  , rti_Incarnate_image_Device
		  , rti_Destroy_image_Device
		  , rti_Incarnate_image_Processor
		  , rti_Destroy_image_Processor
		  , rti_Incarnate_image_Classifier
		  , rti_Destroy_image_Classifier
		};

	protected:
		enum { rtiLast_RQARTStructureProtocol = rti_Destroy_image_Classifier };

	public:
		inline RTInSignal Incarnate_image_Controller( void );
		inline RTInSignal Destroy_image_Controller( void );
		inline RTInSignal Incarnate_image_Device( void );
		inline RTInSignal Destroy_image_Device( void );
		inline RTInSignal Incarnate_image_Processor( void );
		inline RTInSignal Destroy_image_Processor( void );
		inline RTInSignal Incarnate_image_Classifier( void );
		inline RTInSignal Destroy_image_Classifier( void );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RQARTTestDriverProtocol::Conjugate
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );

	protected:
		enum { rtiLast_RQARTStructureProtocol = rtiLast_RQARTTestDriverProtocol };

	public:
		inline RTOutSignal Incarnate_image_Controller( const RTTypedValue & value );
		inline RTOutSignal Incarnate_image_Controller( void );
		inline RTOutSignal Destroy_image_Controller( const int & data );
		inline RTOutSignal Incarnate_image_Device( const RTTypedValue & value );
		inline RTOutSignal Incarnate_image_Device( void );
		inline RTOutSignal Destroy_image_Device( const int & data );
		inline RTOutSignal Incarnate_image_Processor( const RTTypedValue & value );
		inline RTOutSignal Incarnate_image_Processor( void );
		inline RTOutSignal Destroy_image_Processor( const int & data );
		inline RTOutSignal Incarnate_image_Classifier( const RTTypedValue & value );
		inline RTOutSignal Incarnate_image_Classifier( void );
		inline RTOutSignal Destroy_image_Classifier( const int & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline RQARTStructureProtocol::Base::Base( void )
	: RQARTTestDriverProtocol::Base()
{
}

inline RQARTStructureProtocol::Base::~Base( void )
{
}

inline RTInSignal RQARTStructureProtocol::Base::Incarnate_image_Controller( void )
{
	return RTInSignal( this, rti_Incarnate_image_Controller );
}

inline RTInSignal RQARTStructureProtocol::Base::Destroy_image_Controller( void )
{
	return RTInSignal( this, rti_Destroy_image_Controller );
}

inline RTInSignal RQARTStructureProtocol::Base::Incarnate_image_Device( void )
{
	return RTInSignal( this, rti_Incarnate_image_Device );
}

inline RTInSignal RQARTStructureProtocol::Base::Destroy_image_Device( void )
{
	return RTInSignal( this, rti_Destroy_image_Device );
}

inline RTInSignal RQARTStructureProtocol::Base::Incarnate_image_Processor( void )
{
	return RTInSignal( this, rti_Incarnate_image_Processor );
}

inline RTInSignal RQARTStructureProtocol::Base::Destroy_image_Processor( void )
{
	return RTInSignal( this, rti_Destroy_image_Processor );
}

inline RTInSignal RQARTStructureProtocol::Base::Incarnate_image_Classifier( void )
{
	return RTInSignal( this, rti_Incarnate_image_Classifier );
}

inline RTInSignal RQARTStructureProtocol::Base::Destroy_image_Classifier( void )
{
	return RTInSignal( this, rti_Destroy_image_Classifier );
}

inline RQARTStructureProtocol::Conjugate::Conjugate( void )
	: RQARTTestDriverProtocol::Conjugate()
{
}

inline RQARTStructureProtocol::Conjugate::~Conjugate( void )
{
}

inline RTOutSignal RQARTStructureProtocol::Conjugate::Incarnate_image_Controller( const RTTypedValue & value )
{
	return RTOutSignal( this, Base::rti_Incarnate_image_Controller, value.data, value.type );
}

inline RTOutSignal RQARTStructureProtocol::Conjugate::Incarnate_image_Controller( void )
{
	return RTOutSignal( this, Base::rti_Incarnate_image_Controller, (void *)0, &RTType_void );
}

inline RTOutSignal RQARTStructureProtocol::Conjugate::Destroy_image_Controller( const int & data )
{
	return RTOutSignal( this, Base::rti_Destroy_image_Controller, &data, &RTType_int );
}

inline RTOutSignal RQARTStructureProtocol::Conjugate::Incarnate_image_Device( const RTTypedValue & value )
{
	return RTOutSignal( this, Base::rti_Incarnate_image_Device, value.data, value.type );
}

inline RTOutSignal RQARTStructureProtocol::Conjugate::Incarnate_image_Device( void )
{
	return RTOutSignal( this, Base::rti_Incarnate_image_Device, (void *)0, &RTType_void );
}

inline RTOutSignal RQARTStructureProtocol::Conjugate::Destroy_image_Device( const int & data )
{
	return RTOutSignal( this, Base::rti_Destroy_image_Device, &data, &RTType_int );
}

inline RTOutSignal RQARTStructureProtocol::Conjugate::Incarnate_image_Processor( const RTTypedValue & value )
{
	return RTOutSignal( this, Base::rti_Incarnate_image_Processor, value.data, value.type );
}

inline RTOutSignal RQARTStructureProtocol::Conjugate::Incarnate_image_Processor( void )
{
	return RTOutSignal( this, Base::rti_Incarnate_image_Processor, (void *)0, &RTType_void );
}

inline RTOutSignal RQARTStructureProtocol::Conjugate::Destroy_image_Processor( const int & data )
{
	return RTOutSignal( this, Base::rti_Destroy_image_Processor, &data, &RTType_int );
}

inline RTOutSignal RQARTStructureProtocol::Conjugate::Incarnate_image_Classifier( const RTTypedValue & value )
{
	return RTOutSignal( this, Base::rti_Incarnate_image_Classifier, value.data, value.type );
}

inline RTOutSignal RQARTStructureProtocol::Conjugate::Incarnate_image_Classifier( void )
{
	return RTOutSignal( this, Base::rti_Incarnate_image_Classifier, (void *)0, &RTType_void );
}

inline RTOutSignal RQARTStructureProtocol::Conjugate::Destroy_image_Classifier( const int & data )
{
	return RTOutSignal( this, Base::rti_Destroy_image_Classifier, &data, &RTType_int );
}

#endif /* RQARTStructureProtocol_H */

// }}}RME
