// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTTestDriverProtocol'

#ifndef RQARTTestDriverProtocol_H
#define RQARTTestDriverProtocol_H

#ifdef PRAGMA
#pragma interface "RQARTTestDriverProtocol.h"
#endif

#include <RTSystem/VVIG.h>
#include <RQARTExceptionCode.h>
#include <RQARTStartTestNData.h>

struct RQARTTestDriverProtocol
{
	class Base : public RTRootProtocol
	{
	public:
		inline Base( void );
		inline ~Base( void );
		enum
		{
			rti_DriverCompleted = rtiLast_RTRootProtocol + 1
		  , rti_LogMessage
		  , rti_DriverFailed
		  , rti_CompareFailure
		};

	protected:
		enum { rtiLast_RQARTTestDriverProtocol = rti_CompareFailure };

	public:
		inline RTInSignal DriverCompleted( void );
		inline RTInSignal LogMessage( void );
		inline RTInSignal DriverFailed( void );
		inline RTInSignal CompareFailure( void );
		inline RTOutSignal FrameFAIL( void );
		inline RTOutSignal FrameOK( void );
		inline RTOutSignal StartTestN( const RTTypedValue_RQARTStartTestNData & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
	class Conjugate : public RTRootProtocol
	{
	public:
		inline Conjugate( void );
		inline ~Conjugate( void );
		enum
		{
			rti_FrameFAIL = rtiLast_RTRootProtocol + 1
		  , rti_FrameOK
		  , rti_StartTestN
		};

	protected:
		enum { rtiLast_RQARTTestDriverProtocol = rti_StartTestN };

	public:
		inline RTInSignal FrameFAIL( void );
		inline RTInSignal FrameOK( void );
		inline RTInSignal StartTestN( void );
		inline RTOutSignal DriverCompleted( void );
		inline RTOutSignal LogMessage( const RTTypedValue_RTString & data );
		inline RTOutSignal DriverFailed( const RTTypedValue_RQARTExceptionCode & data );
		inline RTOutSignal CompareFailure( const RTTypedValue_RTString & data );
		static const RTProtocolDescriptor rt_class;

	private:
		static const RTSignalDescriptor rt_signals[];
	};
};

inline RQARTTestDriverProtocol::Base::Base( void )
	: RTRootProtocol()
{
}

inline RQARTTestDriverProtocol::Base::~Base( void )
{
}

inline RTInSignal RQARTTestDriverProtocol::Base::DriverCompleted( void )
{
	return RTInSignal( this, rti_DriverCompleted );
}

inline RTInSignal RQARTTestDriverProtocol::Base::LogMessage( void )
{
	return RTInSignal( this, rti_LogMessage );
}

inline RTInSignal RQARTTestDriverProtocol::Base::DriverFailed( void )
{
	return RTInSignal( this, rti_DriverFailed );
}

inline RTInSignal RQARTTestDriverProtocol::Base::CompareFailure( void )
{
	return RTInSignal( this, rti_CompareFailure );
}

inline RTOutSignal RQARTTestDriverProtocol::Base::FrameFAIL( void )
{
	return RTOutSignal( this, Conjugate::rti_FrameFAIL, (const void *)0, &RTType_void );
}

inline RTOutSignal RQARTTestDriverProtocol::Base::FrameOK( void )
{
	return RTOutSignal( this, Conjugate::rti_FrameOK, (const void *)0, &RTType_void );
}

inline RTOutSignal RQARTTestDriverProtocol::Base::StartTestN( const RTTypedValue_RQARTStartTestNData & data )
{
	return RTOutSignal( this, Conjugate::rti_StartTestN, data.data, data.type );
}

inline RQARTTestDriverProtocol::Conjugate::Conjugate( void )
	: RTRootProtocol()
{
}

inline RQARTTestDriverProtocol::Conjugate::~Conjugate( void )
{
}

inline RTInSignal RQARTTestDriverProtocol::Conjugate::FrameFAIL( void )
{
	return RTInSignal( this, rti_FrameFAIL );
}

inline RTInSignal RQARTTestDriverProtocol::Conjugate::FrameOK( void )
{
	return RTInSignal( this, rti_FrameOK );
}

inline RTInSignal RQARTTestDriverProtocol::Conjugate::StartTestN( void )
{
	return RTInSignal( this, rti_StartTestN );
}

inline RTOutSignal RQARTTestDriverProtocol::Conjugate::DriverCompleted( void )
{
	return RTOutSignal( this, Base::rti_DriverCompleted, (const void *)0, &RTType_void );
}

inline RTOutSignal RQARTTestDriverProtocol::Conjugate::LogMessage( const RTTypedValue_RTString & data )
{
	return RTOutSignal( this, Base::rti_LogMessage, data.data, data.type );
}

inline RTOutSignal RQARTTestDriverProtocol::Conjugate::DriverFailed( const RTTypedValue_RQARTExceptionCode & data )
{
	return RTOutSignal( this, Base::rti_DriverFailed, data.data, data.type );
}

inline RTOutSignal RQARTTestDriverProtocol::Conjugate::CompareFailure( const RTTypedValue_RTString & data )
{
	return RTOutSignal( this, Base::rti_CompareFailure, data.data, data.type );
}

#endif /* RQARTTestDriverProtocol_H */

// }}}RME
