// {{{RME classifier 'Logical View::RQART_TestRun_VVIG::RQARTTestHarnessTestRun_VVIG'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "RQARTTestHarnessTestRun_VVIG.h"
#endif

#include <RTSystem/VVIG.h>
#include <RQARTTestHarnessTestRun_VVIG.h>
#include <Image_Classifier_Protocol.h>
#include <Image_Device_Protocol.h>
#include <Image_Processor_Protocol.h>
#include <RQARTAddInProtocol.h>
#include <RQARTExceptionCode.h>
#include <RQARTIncarnateArguments.h>
#include <RQARTStartTestNData.h>
#include <RQARTcap_VVIGimage_ClassifierW.h>
#include <RQARTcap_VVIGimage_ControllerW.h>
#include <RQARTcap_VVIGimage_DeviceW.h>
#include <RQARTcap_VVIGimage_ProcessorW.h>
extern const RTActorClass RQARTTCPServer;

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static RTActor * new_RQARTTestHarnessTestRun_VVIG_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new RQARTTestHarnessTestRun_VVIG_Actor( _rts, _ref );
}

const RTActorClass RQARTTestHarnessTestRun_VVIG =
{
	&RQARTAbstractTestHarness
  , "RQARTTestHarnessTestRun_VVIG"
  , (RTVersionId)0
  , 0
  , (const RTRelayDescriptor *)0
  , new_RQARTTestHarnessTestRun_VVIG_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "Ready"
  , "WaitingForCleanUp"
  , "RunningTest"
  , "Failed"
  , "AreAllDriversCompleted"
};

static const RTInterfaceDescriptor rtg_interfaces_RQART_TCPServer[] =
{
	{
		"AddIn"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_RQART_TCPServer[] =
{
	{
		0
	  , &RQARTAddInProtocol::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_image_Classifier[] =
{
	{
		"RQART_TestHarness"
	  , 1
	}
  , {
		"to_controller"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_image_Classifier[] =
{
	{
		0
	  , &RQARTStructureProtocol::Base::rt_class
	}
  , {
		1
	  , &Image_Classifier_Protocol::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_image_Controller[] =
{
	{
		"RQART_TestHarness"
	  , 1
	}
  , {
		"to_intbus"
	  , 0
	}
  , {
		"to_Image_Device"
	  , 1
	}
  , {
		"to_Image_Processor"
	  , 1
	}
  , {
		"to_Image_Classifier"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_image_Controller[] =
{
	{
		0
	  , &RQARTStructureProtocol::Base::rt_class
	}
  , {
		2
	  , &Image_Device_Protocol::Conjugate::rt_class
	}
  , {
		3
	  , &Image_Processor_Protocol::Conjugate::rt_class
	}
  , {
		4
	  , &Image_Classifier_Protocol::Conjugate::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_image_Device[] =
{
	{
		"RQART_TestHarness"
	  , 1
	}
  , {
		"to_controller"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_image_Device[] =
{
	{
		0
	  , &RQARTStructureProtocol::Base::rt_class
	}
  , {
		1
	  , &Image_Device_Protocol::Base::rt_class
	}
};

static const RTInterfaceDescriptor rtg_interfaces_image_Processor[] =
{
	{
		"RQART_TestHarness"
	  , 1
	}
  , {
		"to_controller"
	  , 1
	}
};

static const RTBindingDescriptor rtg_bindings_image_Processor[] =
{
	{
		0
	  , &RQARTStructureProtocol::Base::rt_class
	}
  , {
		1
	  , &Image_Processor_Protocol::Base::rt_class
	}
};

#define SUPER RQARTAbstractTestHarness_Actor

RQARTTestHarnessTestRun_VVIG_Actor::RQARTTestHarnessTestRun_VVIG_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RQARTAbstractTestHarness_Actor( rtg_rts, rtg_ref )
{
}

RQARTTestHarnessTestRun_VVIG_Actor::~RQARTTestHarnessTestRun_VVIG_Actor( void )
{
}

// {{{RME operation 'Test1Initialize(const int *const)'
void RQARTTestHarnessTestRun_VVIG_Actor::Test1Initialize( const int * const minRunTimes )
{
	// {{{USR
	// Test 1 initialization

	RQARTStartTestNData driverData;
	driverData.nCurrentTest = 1;
	nCurrentInstances = 5;
	nEnvironmentIndex = 0;
	PrepareToStartTest(minRunTimes);

	// Auto-create any roles not explicitly created.
	// Auto-create: incarnate the wrappers for the drivers if they don't already exist.
	// If they do exist, prepare them for the next test.
	RQARTIncarnateArguments driverArg;
	if (!RQART_Driver2.isBoundAt(0))
	{
		driverArg.pCapsuleClass = &RQARTcap_VVIGimage_ControllerW;
		driverArg.cardinalityIndex = 0;
		if (!CreateCapsuleRole(image_Controller, &driverArg)) return;
	}
	if (!RQART_Driver3.isBoundAt(0))
	{
		driverArg.pCapsuleClass = &RQARTcap_VVIGimage_DeviceW;
		driverArg.cardinalityIndex = 0;
		if (!CreateCapsuleRole(image_Device, &driverArg)) return;
	}
	if (!RQART_Driver4.isBoundAt(0))
	{
		driverArg.pCapsuleClass = &RQARTcap_VVIGimage_ProcessorW;
		driverArg.cardinalityIndex = 0;
		if (!CreateCapsuleRole(image_Processor, &driverArg)) return;
	}
	if (!RQART_Driver1.isBoundAt(0))
	{
		driverArg.pCapsuleClass = &RQARTcap_VVIGimage_ClassifierW;
		driverArg.cardinalityIndex = 0;
		if (!CreateCapsuleRole(image_Classifier, &driverArg)) return;
	}
	// Auto-create: start the drivers that receive their first message
	if (RQART_Driver2.isBoundAt(0))
	{
		driverData.nMinRunTime = nMinRunTimes[1];
		driverData.nCardinalityIndex = 0;
		RQART_Driver2.StartTestN(driverData).sendAt(0, Panic);
	}
	if (RQART_Driver3.isBoundAt(0))
	{
		driverData.nMinRunTime = nMinRunTimes[2];
		driverData.nCardinalityIndex = 0;
		RQART_Driver3.StartTestN(driverData).sendAt(0, Panic);
	}
	if (RQART_Driver4.isBoundAt(0))
	{
		driverData.nMinRunTime = nMinRunTimes[3];
		driverData.nCardinalityIndex = 0;
		RQART_Driver4.StartTestN(driverData).sendAt(0, Panic);
	}
	if (RQART_Driver1.isBoundAt(0))
	{
		driverData.nMinRunTime = nMinRunTimes[4];
		driverData.nCardinalityIndex = 0;
		RQART_Driver1.StartTestN(driverData).sendAt(0, Panic);
	}


	// }}}USR
}
// }}}RME

// {{{RME operation 'Test1Complete()'
void RQARTTestHarnessTestRun_VVIG_Actor::Test1Complete( void )
{
	// {{{USR
	// Test 1 normal completion

	// }}}USR
}
// }}}RME

// {{{RME operation 'Test1CleanUp()'
void RQARTTestHarnessTestRun_VVIG_Actor::Test1CleanUp( void )
{
	// {{{USR
	// Test 1 clean up

	// }}}USR
}
// }}}RME

// {{{RME operation 'InitializeTest(const int *const)'
void RQARTTestHarnessTestRun_VVIG_Actor::InitializeTest( const int * const minRunTimes )
{
	// {{{USR
	// Initialize a test.

	switch (nCurrentTest)
	{
	case 1:
		Test1Initialize(minRunTimes);
		break;
	}


	// }}}USR
}
// }}}RME

// {{{RME operation 'CompleteTest()'
void RQARTTestHarnessTestRun_VVIG_Actor::CompleteTest( void )
{
	// {{{USR
	// Complete a test normally.

	CancelTimeoutTimer();

	// test-specific completion
	switch (nCurrentTest)
	{
	case 1:
		Test1Complete();
		break;
	}

	addIn.TestCompleted().send();


	// }}}USR
}
// }}}RME

// {{{RME operation 'CleanUpTest()'
void RQARTTestHarnessTestRun_VVIG_Actor::CleanUpTest( void )
{
	// {{{USR
	// Clean up the current test.
	switch (nCurrentTest)
	{
	case 1:
		Test1CleanUp();
		break;
	}

	addIn.TestCleanedUp().send();

	// }}}USR
}
// }}}RME

// {{{RME operation 'DestroyDrivers()'
void RQARTTestHarnessTestRun_VVIG_Actor::DestroyDrivers( void )
{
	// {{{USR
	// destroy the top-level test drivers. Ignore destroy failures.
	DestroyCapsuleRole(image_Classifier);
	DestroyCapsuleRole(image_Controller);
	DestroyCapsuleRole(image_Device);
	DestroyCapsuleRole(image_Processor);


	// }}}USR
}
// }}}RME

// {{{RME operation 'DestroyCUTs()'
void RQARTTestHarnessTestRun_VVIG_Actor::DestroyCUTs( void )
{
	// {{{USR
	// destroy the capsules under test (if any). Ignore destroy failures.

	// }}}USR
}
// }}}RME

int RQARTTestHarnessTestRun_VVIG_Actor::_followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_compId )
	{
	case 1:
		// RQART_TCPServer
		switch( rtg_portId )
		{
		case 0:
			// AddIn
			if( rtg_repIndex < 1 )
			{
				// addIn
				rtg_end.port = &addIn;
				rtg_end.index = rtg_repIndex;
				return 1;
			}
			break;
		default:
			break;
		}
	case 2:
		// image_Classifier
		switch( rtg_portId )
		{
		case 0:
			// RQART_TestHarness
			if( rtg_repIndex < 1 )
			{
				// RQART_Driver1
				rtg_end.port = &RQART_Driver1;
				rtg_end.index = rtg_repIndex;
				return 1;
			}
			break;
		case 1:
			// to_controller
			if( rtg_repIndex < 1 )
			{
				// image_Controller/to_Image_Classifier
				return image_Controller._followIn( rtg_end, 4, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 3:
		// image_Controller
		switch( rtg_portId )
		{
		case 0:
			// RQART_TestHarness
			if( rtg_repIndex < 1 )
			{
				// RQART_Driver2
				rtg_end.port = &RQART_Driver2;
				rtg_end.index = rtg_repIndex;
				return 1;
			}
			break;
		case 2:
			// to_Image_Device
			if( rtg_repIndex < 1 )
			{
				// image_Device/to_controller
				return image_Device._followIn( rtg_end, 1, rtg_repIndex );
			}
			break;
		case 3:
			// to_Image_Processor
			if( rtg_repIndex < 1 )
			{
				// image_Processor/to_controller
				return image_Processor._followIn( rtg_end, 1, rtg_repIndex );
			}
			break;
		case 4:
			// to_Image_Classifier
			if( rtg_repIndex < 1 )
			{
				// image_Classifier/to_controller
				return image_Classifier._followIn( rtg_end, 1, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 4:
		// image_Device
		switch( rtg_portId )
		{
		case 0:
			// RQART_TestHarness
			if( rtg_repIndex < 1 )
			{
				// RQART_Driver3
				rtg_end.port = &RQART_Driver3;
				rtg_end.index = rtg_repIndex;
				return 1;
			}
			break;
		case 1:
			// to_controller
			if( rtg_repIndex < 1 )
			{
				// image_Controller/to_Image_Device
				return image_Controller._followIn( rtg_end, 2, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	case 5:
		// image_Processor
		switch( rtg_portId )
		{
		case 0:
			// RQART_TestHarness
			if( rtg_repIndex < 1 )
			{
				// RQART_Driver4
				rtg_end.port = &RQART_Driver4;
				rtg_end.index = rtg_repIndex;
				return 1;
			}
			break;
		case 1:
			// to_controller
			if( rtg_repIndex < 1 )
			{
				// image_Controller/to_Image_Processor
				return image_Controller._followIn( rtg_end, 3, rtg_repIndex );
			}
			break;
		default:
			break;
		}
	default:
		break;
	}
	return RQARTAbstractTestHarness_Actor::_followOutV( rtg_end, rtg_compId, rtg_portId, rtg_repIndex );
}

// {{{RME transition ':TOP:Initial:Initial'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition1_Initial
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition1_Initial( rtdata, rtport )
INLINE_METHODS void RQARTTestHarnessTestRun_VVIG_Actor::transition1_Initial( const void * rtdata, RTProtocol * rtport )
{
	// {{{USR
	addIn.SetPort(27111).send();

	nMaxInstances = 5;
	nMinRunTimes = new int[nMaxInstances];
	if (!nMinRunTimes)
	{
		RQARTExceptionCode exCode = eRQARTMemoryError;
		RQART_Exception.error(RTTypedValue(&exCode)).raise();
		return;
	}
	ZeroMinRunTimes();

	nNumDrivers = new int[1];
	if (!nNumDrivers)
	{
		RQARTExceptionCode exCode = eRQARTMemoryError;
		RQART_Exception.error(RTTypedValue(&exCode)).raise();
		return;
	}
	nNumDrivers[0] = 4;

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:AreAllDriversCompleted:True'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition11_True
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition11_True( rtdata, rtport )
INLINE_METHODS void RQARTTestHarnessTestRun_VVIG_Actor::transition11_True( const void * rtdata, RTProtocol * rtport )
{
	// {{{USR
	// this test has completed
	CompleteTest();

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:J4367A9A2001D:Incarnate_image_Controller'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition16_Incarnate_image_Controller
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition16_Incarnate_image_Controller( rtdata, rtport )
INLINE_METHODS void RQARTTestHarnessTestRun_VVIG_Actor::transition16_Incarnate_image_Controller( const void * rtdata, RQARTStructureProtocol::Base * rtport )
{
	// {{{USR
	const RQARTIncarnateArguments *const pArgs = (const RQARTIncarnateArguments *const)rtdata;
	if (CreateCapsuleRole(image_Controller, pArgs))
	{
		rtport->FrameOK().reply();
		RQARTStartTestNData driverData;
		driverData.nCurrentTest = nCurrentTest;
		driverData.nMinRunTime = nMinRunTimes[pArgs->instanceIndex];
		driverData.nCardinalityIndex = pArgs->cardinalityIndex;
		RQART_Driver2.StartTestN(driverData).sendAt(pArgs->cardinalityIndex, Panic);
	}
	else
		rtport->FrameFAIL().reply();

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:J4367A9A20038:Destroy_image_Controller'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition17_Destroy_image_Controller
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition17_Destroy_image_Controller( rtdata, rtport )
INLINE_METHODS void RQARTTestHarnessTestRun_VVIG_Actor::transition17_Destroy_image_Controller( const int * rtdata, RQARTStructureProtocol::Base * rtport )
{
	// {{{USR
	if (!DestroyCapsuleRole(image_Controller, *rtdata))
	{
		RQARTExceptionCode exCode = eRQARTDestroyError;
		RQART_Exception.error(RTTypedValue(&exCode)).raise();
		return;
	}

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:J4367A9A20057:Incarnate_image_Device'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition18_Incarnate_image_Device
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition18_Incarnate_image_Device( rtdata, rtport )
INLINE_METHODS void RQARTTestHarnessTestRun_VVIG_Actor::transition18_Incarnate_image_Device( const void * rtdata, RQARTStructureProtocol::Base * rtport )
{
	// {{{USR
	const RQARTIncarnateArguments *const pArgs = (const RQARTIncarnateArguments *const)rtdata;
	if (CreateCapsuleRole(image_Device, pArgs))
	{
		rtport->FrameOK().reply();
		RQARTStartTestNData driverData;
		driverData.nCurrentTest = nCurrentTest;
		driverData.nMinRunTime = nMinRunTimes[pArgs->instanceIndex];
		driverData.nCardinalityIndex = pArgs->cardinalityIndex;
		RQART_Driver3.StartTestN(driverData).sendAt(pArgs->cardinalityIndex, Panic);
	}
	else
		rtport->FrameFAIL().reply();

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:J4367A9A20074:Destroy_image_Device'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition19_Destroy_image_Device
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition19_Destroy_image_Device( rtdata, rtport )
INLINE_METHODS void RQARTTestHarnessTestRun_VVIG_Actor::transition19_Destroy_image_Device( const int * rtdata, RQARTStructureProtocol::Base * rtport )
{
	// {{{USR
	if (!DestroyCapsuleRole(image_Device, *rtdata))
	{
		RQARTExceptionCode exCode = eRQARTDestroyError;
		RQART_Exception.error(RTTypedValue(&exCode)).raise();
		return;
	}

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:J4367A9A20094:Incarnate_image_Processor'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition20_Incarnate_image_Processor
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition20_Incarnate_image_Processor( rtdata, rtport )
INLINE_METHODS void RQARTTestHarnessTestRun_VVIG_Actor::transition20_Incarnate_image_Processor( const void * rtdata, RQARTStructureProtocol::Base * rtport )
{
	// {{{USR
	const RQARTIncarnateArguments *const pArgs = (const RQARTIncarnateArguments *const)rtdata;
	if (CreateCapsuleRole(image_Processor, pArgs))
	{
		rtport->FrameOK().reply();
		RQARTStartTestNData driverData;
		driverData.nCurrentTest = nCurrentTest;
		driverData.nMinRunTime = nMinRunTimes[pArgs->instanceIndex];
		driverData.nCardinalityIndex = pArgs->cardinalityIndex;
		RQART_Driver4.StartTestN(driverData).sendAt(pArgs->cardinalityIndex, Panic);
	}
	else
		rtport->FrameFAIL().reply();

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:J4367A9A200B6:Destroy_image_Processor'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition21_Destroy_image_Processor
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition21_Destroy_image_Processor( rtdata, rtport )
INLINE_METHODS void RQARTTestHarnessTestRun_VVIG_Actor::transition21_Destroy_image_Processor( const int * rtdata, RQARTStructureProtocol::Base * rtport )
{
	// {{{USR
	if (!DestroyCapsuleRole(image_Processor, *rtdata))
	{
		RQARTExceptionCode exCode = eRQARTDestroyError;
		RQART_Exception.error(RTTypedValue(&exCode)).raise();
		return;
	}

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:J4367A9A200DA:Incarnate_image_Classifier'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition22_Incarnate_image_Classifier
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition22_Incarnate_image_Classifier( rtdata, rtport )
INLINE_METHODS void RQARTTestHarnessTestRun_VVIG_Actor::transition22_Incarnate_image_Classifier( const void * rtdata, RQARTStructureProtocol::Base * rtport )
{
	// {{{USR
	const RQARTIncarnateArguments *const pArgs = (const RQARTIncarnateArguments *const)rtdata;
	if (CreateCapsuleRole(image_Classifier, pArgs))
	{
		rtport->FrameOK().reply();
		RQARTStartTestNData driverData;
		driverData.nCurrentTest = nCurrentTest;
		driverData.nMinRunTime = nMinRunTimes[pArgs->instanceIndex];
		driverData.nCardinalityIndex = pArgs->cardinalityIndex;
		RQART_Driver1.StartTestN(driverData).sendAt(pArgs->cardinalityIndex, Panic);
	}
	else
		rtport->FrameFAIL().reply();

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:J4367A9A200FA:Destroy_image_Classifier'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition23_Destroy_image_Classifier
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition23_Destroy_image_Classifier( rtdata, rtport )
INLINE_METHODS void RQARTTestHarnessTestRun_VVIG_Actor::transition23_Destroy_image_Classifier( const int * rtdata, RQARTStructureProtocol::Base * rtport )
{
	// {{{USR
	if (!DestroyCapsuleRole(image_Classifier, *rtdata))
	{
		RQARTExceptionCode exCode = eRQARTDestroyError;
		RQART_Exception.error(RTTypedValue(&exCode)).raise();
		return;
	}

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:J4367A9A20124:LogMessage'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition24_LogMessage
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition24_LogMessage( rtdata, rtport )
INLINE_METHODS void RQARTTestHarnessTestRun_VVIG_Actor::transition24_LogMessage( const RTString * rtdata, RQARTStructureProtocol::Base * rtport )
{
	// {{{USR
	addIn.LogMessage(*rtdata).send();

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:J4367A9A20148:CompareFailure'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::transition25_CompareFailure
#define CALLSUPER RQARTAbstractTestHarness_Actor::transition25_CompareFailure( rtdata, rtport )
INLINE_METHODS void RQARTTestHarnessTestRun_VVIG_Actor::transition25_CompareFailure( const RTString * rtdata, RQARTStructureProtocol::Base * rtport )
{
	// {{{USR
	addIn.CompareFailure(*rtdata).send();

	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain1_Initial( void )
{
	// transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	transition1_Initial( msg->data, msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain12_errorException( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' transition ':TOP:Junction4:errorException'
	rtgChainBegin( 1, "errorException" );
	exitToChainState( 1, rtg_parent_state );
	rtgTransitionBegin();
	transition12_errorException( msg->data, (Exception::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 5 );
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain2_timeout( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' transition ':TOP:Junction1:timeout'
	rtgChainBegin( 1, "timeout" );
	exitToChainState( 1, rtg_parent_state );
	rtgTransitionBegin();
	transition2_timeout( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain6_timerCompleted( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' transition ':TOP:Junction2:timerCompleted'
	rtgChainBegin( 1, "timerCompleted" );
	rtgTransitionBegin();
	transition6_timerCompleted( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain24_LogMessage( void )
{
	// transition ':TOP:J4367A9A20124:LogMessage'
	rtgChainBegin( 1, "LogMessage" );
	rtgTransitionBegin();
	transition24_LogMessage( (const RTString *)msg->data, (RQARTStructureProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain13_DriverFailed( void )
{
	// transition ':TOP:Junction5:DriverFailed'
	rtgChainBegin( 1, "DriverFailed" );
	exitToChainState( 1, rtg_parent_state );
	rtgTransitionBegin();
	transition13_DriverFailed( msg->data, msg->sap() );
	rtgTransitionEnd();
	enterState( 5 );
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain25_CompareFailure( void )
{
	// transition ':TOP:J4367A9A20148:CompareFailure'
	rtgChainBegin( 1, "CompareFailure" );
	rtgTransitionBegin();
	transition25_CompareFailure( (const RTString *)msg->data, (RQARTStructureProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain16_Incarnate_image_Controller( void )
{
	// transition ':TOP:J4367A9A2001D:Incarnate_image_Controller'
	rtgChainBegin( 1, "Incarnate_image_Controller" );
	rtgTransitionBegin();
	transition16_Incarnate_image_Controller( msg->data, (RQARTStructureProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain17_Destroy_image_Controller( void )
{
	// transition ':TOP:J4367A9A20038:Destroy_image_Controller'
	rtgChainBegin( 1, "Destroy_image_Controller" );
	rtgTransitionBegin();
	transition17_Destroy_image_Controller( (const int *)msg->data, (RQARTStructureProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain18_Incarnate_image_Device( void )
{
	// transition ':TOP:J4367A9A20057:Incarnate_image_Device'
	rtgChainBegin( 1, "Incarnate_image_Device" );
	rtgTransitionBegin();
	transition18_Incarnate_image_Device( msg->data, (RQARTStructureProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain19_Destroy_image_Device( void )
{
	// transition ':TOP:J4367A9A20074:Destroy_image_Device'
	rtgChainBegin( 1, "Destroy_image_Device" );
	rtgTransitionBegin();
	transition19_Destroy_image_Device( (const int *)msg->data, (RQARTStructureProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain20_Incarnate_image_Processor( void )
{
	// transition ':TOP:J4367A9A20094:Incarnate_image_Processor'
	rtgChainBegin( 1, "Incarnate_image_Processor" );
	rtgTransitionBegin();
	transition20_Incarnate_image_Processor( msg->data, (RQARTStructureProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain21_Destroy_image_Processor( void )
{
	// transition ':TOP:J4367A9A200B6:Destroy_image_Processor'
	rtgChainBegin( 1, "Destroy_image_Processor" );
	rtgTransitionBegin();
	transition21_Destroy_image_Processor( (const int *)msg->data, (RQARTStructureProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain22_Incarnate_image_Classifier( void )
{
	// transition ':TOP:J4367A9A200DA:Incarnate_image_Classifier'
	rtgChainBegin( 1, "Incarnate_image_Classifier" );
	rtgTransitionBegin();
	transition22_Incarnate_image_Classifier( msg->data, (RQARTStructureProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain23_Destroy_image_Classifier( void )
{
	// transition ':TOP:J4367A9A200FA:Destroy_image_Classifier'
	rtgChainBegin( 1, "Destroy_image_Classifier" );
	rtgTransitionBegin();
	transition23_Destroy_image_Classifier( (const int *)msg->data, (RQARTStructureProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain8_StartTest( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' transition ':TOP:Ready:Junction8:StartTest'
	rtgChainBegin( 2, "StartTest" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition8_StartTest( msg->data, (RQARTAddInProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 4 );
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain3_Reset( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' transition ':TOP:Ready:Junction2:Reset'
	rtgChainBegin( 2, "Reset" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition3_Reset( msg->data, (RQARTAddInProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain4_SetMaxTime( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' transition ':TOP:Ready:Junction5:SetMaxTime'
	rtgChainBegin( 2, "SetMaxTime" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition4_SetMaxTime( (const int *)msg->data, (RQARTAddInProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain14_SetControllerVersion( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' transition ':TOP:Ready:Junction9:SetControllerVersion'
	rtgChainBegin( 2, "SetControllerVersion" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition14_SetControllerVersion( (const int *)msg->data, (RQARTAddInProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain7_cleanUp( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' transition ':TOP:WaitingForCleanUp:Junction2:cleanUp'
	rtgChainBegin( 3, "cleanUp" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition7_cleanUp( msg->data, (RQARTAddInProtocol::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain5_timerCompleted( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' transition ':TOP:RunningTest:Junction4:timerCompleted'
	rtgChainBegin( 4, "timerCompleted" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition5_timerCompleted( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
	if( choicePoint1_AreAllDriversCompleted( msg->data, msg->sap() ) )
		chain11_True();
	else
		chain10_False();
}

// {{{RME choicePoint ':TOP:AreAllDriversCompleted'
#define SUPERMETHOD RQARTAbstractTestHarness_Actor::choicePoint1_AreAllDriversCompleted
#define CALLSUPER RQARTAbstractTestHarness_Actor::choicePoint1_AreAllDriversCompleted( rtdata, rtport )
INLINE_METHODS int RQARTTestHarnessTestRun_VVIG_Actor::choicePoint1_AreAllDriversCompleted( const void * rtdata, RTProtocol * rtport )
{
	// {{{USR
	return (nCompletedDrivers >= nNumDrivers[nCurrentTest - 1]) &&
		(nTimerCount == 0);
	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain11_True( void )
{
	// transition ':TOP:AreAllDriversCompleted:True'
	rtgChainBegin( 6, "True" );
	rtgTransitionBegin();
	transition11_True( msg->data, msg->sap() );
	rtgTransitionEnd();
	enterState( 3 );
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain10_False( void )
{
	// transition ':TOP:AreAllDriversCompleted:False'
	rtgChainBegin( 6, "False" );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 4 );
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain9_DriverCompleted( void )
{
	// transition ':TOP:RunningTest:Junction1:DriverCompleted'
	rtgChainBegin( 4, "DriverCompleted" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition9_DriverCompleted( msg->data, msg->sap() );
	rtgTransitionEnd();
	if( choicePoint1_AreAllDriversCompleted( msg->data, msg->sap() ) )
		chain11_True();
	else
		chain10_False();
}

INLINE_CHAINS void RQARTTestHarnessTestRun_VVIG_Actor::chain15_ignoreMessages( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' transition ':TOP:Failed:Junction7:ignoreMessages'
	rtgChainBegin( 5, "ignoreMessages" );
	rtgTransitionBegin();
	transition15_ignoreMessages( msg->data, msg->sap() );
	rtgTransitionEnd();
}

void RQARTTestHarnessTestRun_VVIG_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain1_Initial();
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestBase' port 'RQART_Exception'
				switch( signalIndex )
				{
				case Exception::Base::rti_error:
					chain12_errorException();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			case 4:
				// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' port 'RQART_Timer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					if( guard2_timeout_event1( msg->data, (Timing::Base *)msg->sap() ) )
					{
						chain2_timeout();
						return;
					}
					if( guard6_timerCompleted_event1( msg->data, (Timing::Base *)msg->sap() ) )
					{
						chain6_timerCompleted();
						return;
					}
					break;
				default:
					break;
				}
				break;
				// }}}RME
			case 6:
				// {{{RME port 'RQART_Driver1'
				switch( signalIndex )
				{
				case RQARTStructureProtocol::Base::rti_LogMessage:
					chain24_LogMessage();
					return;
				case RQARTStructureProtocol::Base::rti_DriverFailed:
					chain13_DriverFailed();
					return;
				case RQARTStructureProtocol::Base::rti_CompareFailure:
					chain25_CompareFailure();
					return;
				case RQARTStructureProtocol::Base::rti_Incarnate_image_Controller:
					chain16_Incarnate_image_Controller();
					return;
				case RQARTStructureProtocol::Base::rti_Destroy_image_Controller:
					chain17_Destroy_image_Controller();
					return;
				case RQARTStructureProtocol::Base::rti_Incarnate_image_Device:
					chain18_Incarnate_image_Device();
					return;
				case RQARTStructureProtocol::Base::rti_Destroy_image_Device:
					chain19_Destroy_image_Device();
					return;
				case RQARTStructureProtocol::Base::rti_Incarnate_image_Processor:
					chain20_Incarnate_image_Processor();
					return;
				case RQARTStructureProtocol::Base::rti_Destroy_image_Processor:
					chain21_Destroy_image_Processor();
					return;
				case RQARTStructureProtocol::Base::rti_Incarnate_image_Classifier:
					chain22_Incarnate_image_Classifier();
					return;
				case RQARTStructureProtocol::Base::rti_Destroy_image_Classifier:
					chain23_Destroy_image_Classifier();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			case 7:
				// {{{RME port 'RQART_Driver2'
				switch( signalIndex )
				{
				case RQARTStructureProtocol::Base::rti_LogMessage:
					chain24_LogMessage();
					return;
				case RQARTStructureProtocol::Base::rti_DriverFailed:
					chain13_DriverFailed();
					return;
				case RQARTStructureProtocol::Base::rti_CompareFailure:
					chain25_CompareFailure();
					return;
				case RQARTStructureProtocol::Base::rti_Incarnate_image_Controller:
					chain16_Incarnate_image_Controller();
					return;
				case RQARTStructureProtocol::Base::rti_Destroy_image_Controller:
					chain17_Destroy_image_Controller();
					return;
				case RQARTStructureProtocol::Base::rti_Incarnate_image_Device:
					chain18_Incarnate_image_Device();
					return;
				case RQARTStructureProtocol::Base::rti_Destroy_image_Device:
					chain19_Destroy_image_Device();
					return;
				case RQARTStructureProtocol::Base::rti_Incarnate_image_Processor:
					chain20_Incarnate_image_Processor();
					return;
				case RQARTStructureProtocol::Base::rti_Destroy_image_Processor:
					chain21_Destroy_image_Processor();
					return;
				case RQARTStructureProtocol::Base::rti_Incarnate_image_Classifier:
					chain22_Incarnate_image_Classifier();
					return;
				case RQARTStructureProtocol::Base::rti_Destroy_image_Classifier:
					chain23_Destroy_image_Classifier();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			case 8:
				// {{{RME port 'RQART_Driver3'
				switch( signalIndex )
				{
				case RQARTStructureProtocol::Base::rti_LogMessage:
					chain24_LogMessage();
					return;
				case RQARTStructureProtocol::Base::rti_DriverFailed:
					chain13_DriverFailed();
					return;
				case RQARTStructureProtocol::Base::rti_CompareFailure:
					chain25_CompareFailure();
					return;
				case RQARTStructureProtocol::Base::rti_Incarnate_image_Controller:
					chain16_Incarnate_image_Controller();
					return;
				case RQARTStructureProtocol::Base::rti_Destroy_image_Controller:
					chain17_Destroy_image_Controller();
					return;
				case RQARTStructureProtocol::Base::rti_Incarnate_image_Device:
					chain18_Incarnate_image_Device();
					return;
				case RQARTStructureProtocol::Base::rti_Destroy_image_Device:
					chain19_Destroy_image_Device();
					return;
				case RQARTStructureProtocol::Base::rti_Incarnate_image_Processor:
					chain20_Incarnate_image_Processor();
					return;
				case RQARTStructureProtocol::Base::rti_Destroy_image_Processor:
					chain21_Destroy_image_Processor();
					return;
				case RQARTStructureProtocol::Base::rti_Incarnate_image_Classifier:
					chain22_Incarnate_image_Classifier();
					return;
				case RQARTStructureProtocol::Base::rti_Destroy_image_Classifier:
					chain23_Destroy_image_Classifier();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			case 9:
				// {{{RME port 'RQART_Driver4'
				switch( signalIndex )
				{
				case RQARTStructureProtocol::Base::rti_LogMessage:
					chain24_LogMessage();
					return;
				case RQARTStructureProtocol::Base::rti_DriverFailed:
					chain13_DriverFailed();
					return;
				case RQARTStructureProtocol::Base::rti_CompareFailure:
					chain25_CompareFailure();
					return;
				case RQARTStructureProtocol::Base::rti_Incarnate_image_Controller:
					chain16_Incarnate_image_Controller();
					return;
				case RQARTStructureProtocol::Base::rti_Destroy_image_Controller:
					chain17_Destroy_image_Controller();
					return;
				case RQARTStructureProtocol::Base::rti_Incarnate_image_Device:
					chain18_Incarnate_image_Device();
					return;
				case RQARTStructureProtocol::Base::rti_Destroy_image_Device:
					chain19_Destroy_image_Device();
					return;
				case RQARTStructureProtocol::Base::rti_Incarnate_image_Processor:
					chain20_Incarnate_image_Processor();
					return;
				case RQARTStructureProtocol::Base::rti_Destroy_image_Processor:
					chain21_Destroy_image_Processor();
					return;
				case RQARTStructureProtocol::Base::rti_Incarnate_image_Classifier:
					chain22_Incarnate_image_Classifier();
					return;
				case RQARTStructureProtocol::Base::rti_Destroy_image_Classifier:
					chain23_Destroy_image_Classifier();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' state ':TOP:Ready'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 5:
				// {{{RME port 'addIn'
				switch( signalIndex )
				{
				case RQARTAddInProtocol::Base::rti_StartTest:
					chain8_StartTest();
					return;
				case RQARTAddInProtocol::Base::rti_Reset:
					chain3_Reset();
					return;
				case RQARTAddInProtocol::Base::rti_SetMaxTime:
					chain4_SetMaxTime();
					return;
				case RQARTAddInProtocol::Base::rti_SetRQARTControllerVersion:
					chain14_SetControllerVersion();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 3:
			// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' state ':TOP:WaitingForCleanUp'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 5:
				// {{{RME port 'addIn'
				switch( signalIndex )
				{
				case RQARTAddInProtocol::Base::rti_CleanUpTest:
					chain7_cleanUp();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 4:
			// {{{RME state ':TOP:RunningTest'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 4:
				// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' port 'RQART_Timer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					if( guard5_timerCompleted_event1( msg->data, (Timing::Base *)msg->sap() ) )
					{
						chain5_timerCompleted();
						return;
					}
					break;
				default:
					break;
				}
				break;
				// }}}RME
			case 6:
				// {{{RME port 'RQART_Driver1'
				switch( signalIndex )
				{
				case RQARTStructureProtocol::Base::rti_DriverCompleted:
					chain9_DriverCompleted();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			case 7:
				// {{{RME port 'RQART_Driver2'
				switch( signalIndex )
				{
				case RQARTStructureProtocol::Base::rti_DriverCompleted:
					chain9_DriverCompleted();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			case 8:
				// {{{RME port 'RQART_Driver3'
				switch( signalIndex )
				{
				case RQARTStructureProtocol::Base::rti_DriverCompleted:
					chain9_DriverCompleted();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			case 9:
				// {{{RME port 'RQART_Driver4'
				switch( signalIndex )
				{
				case RQARTStructureProtocol::Base::rti_DriverCompleted:
					chain9_DriverCompleted();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 5:
			// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestHarness' state ':TOP:Failed'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestBase' port 'RQART_Exception'
				chain15_ignoreMessages();
				return;
				// }}}RME
			case 4:
				// {{{RME port 'RQART_Timer'
				chain15_ignoreMessages();
				return;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * RQARTTestHarnessTestRun_VVIG_Actor::getActorData( void ) const
{
	return &RQARTTestHarnessTestRun_VVIG_Actor::rtg_class;
}

const RTActor_class RQARTTestHarnessTestRun_VVIG_Actor::rtg_class =
{
	&RQARTAbstractTestHarness_Actor::rtg_class
  , rtg_state_names
  , 5
  , RQARTTestHarnessTestRun_VVIG_Actor::rtg_parent_state
  , &RQARTTestHarnessTestRun_VVIG
  , 5
  , RQARTTestHarnessTestRun_VVIG_Actor::rtg_capsule_roles
  , 9
  , RQARTTestHarnessTestRun_VVIG_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId RQARTTestHarnessTestRun_VVIG_Actor::rtg_parent_state[] =
{
	0
  , 1
  , 1
  , 1
  , 1
};

const RTComponentDescriptor RQARTTestHarnessTestRun_VVIG_Actor::rtg_capsule_roles[] =
{
	{
		"RQART_TCPServer"
	  , &RQARTTCPServer
	  , RTOffsetOf( RQARTTestHarnessTestRun_VVIG_Actor, RQART_TCPServer )
	  , 1
	  , RTComponentDescriptor::Fixed
	  , 1
	  , 1 // cardinality
	  , 1
	  , rtg_interfaces_RQART_TCPServer
	  , 1
	  , rtg_bindings_RQART_TCPServer
	}
  , {
		"image_Classifier"
	  , &RQARTcap_VVIGimage_ClassifierW
	  , RTOffsetOf( RQARTTestHarnessTestRun_VVIG_Actor, image_Classifier )
	  , 2
	  , RTComponentDescriptor::Optional
	  , 1
	  , 1 // cardinality
	  , 2
	  , rtg_interfaces_image_Classifier
	  , 2
	  , rtg_bindings_image_Classifier
	}
  , {
		"image_Controller"
	  , &RQARTcap_VVIGimage_ControllerW
	  , RTOffsetOf( RQARTTestHarnessTestRun_VVIG_Actor, image_Controller )
	  , 3
	  , RTComponentDescriptor::Optional
	  , 1
	  , 1 // cardinality
	  , 5
	  , rtg_interfaces_image_Controller
	  , 4
	  , rtg_bindings_image_Controller
	}
  , {
		"image_Device"
	  , &RQARTcap_VVIGimage_DeviceW
	  , RTOffsetOf( RQARTTestHarnessTestRun_VVIG_Actor, image_Device )
	  , 4
	  , RTComponentDescriptor::Optional
	  , 1
	  , 1 // cardinality
	  , 2
	  , rtg_interfaces_image_Device
	  , 2
	  , rtg_bindings_image_Device
	}
  , {
		"image_Processor"
	  , &RQARTcap_VVIGimage_ProcessorW
	  , RTOffsetOf( RQARTTestHarnessTestRun_VVIG_Actor, image_Processor )
	  , 5
	  , RTComponentDescriptor::Optional
	  , 1
	  , 1 // cardinality
	  , 2
	  , rtg_interfaces_image_Processor
	  , 2
	  , rtg_bindings_image_Processor
	}
};

const RTPortDescriptor RQARTTestHarnessTestRun_VVIG_Actor::rtg_ports[] =
{
	{
		"RQART_Exception"
	  , (const char *)0
	  , &Exception::Base::rt_class
	  , RTOffsetOf( RQARTTestHarnessTestRun_VVIG_Actor, RQARTAbstractTestBase_Actor::RQART_Exception )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"RQART_Frame"
	  , (const char *)0
	  , &Frame::Base::rt_class
	  , RTOffsetOf( RQARTTestHarnessTestRun_VVIG_Actor, RQARTAbstractTestBase_Actor::RQART_Frame )
	  , 1 // cardinality
	  , 2
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"RQART_Log"
	  , (const char *)0
	  , &Log::Base::rt_class
	  , RTOffsetOf( RQARTTestHarnessTestRun_VVIG_Actor, RQARTAbstractTestBase_Actor::RQART_Log )
	  , 1 // cardinality
	  , 3
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"RQART_Timer"
	  , (const char *)0
	  , &Timing::Base::rt_class
	  , RTOffsetOf( RQARTTestHarnessTestRun_VVIG_Actor, RQARTAbstractTestHarness_Actor::RQART_Timer )
	  , 1 // cardinality
	  , 4
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"addIn"
	  , (const char *)0
	  , &RQARTAddInProtocol::Base::rt_class
	  , RTOffsetOf( RQARTTestHarnessTestRun_VVIG_Actor, RQARTAbstractTestHarness_Actor::addIn )
	  , 1 // cardinality
	  , 5
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"RQART_Driver1"
	  , (const char *)0
	  , &RQARTStructureProtocol::Base::rt_class
	  , RTOffsetOf( RQARTTestHarnessTestRun_VVIG_Actor, RQARTTestHarnessTestRun_VVIG_Actor::RQART_Driver1 )
	  , 1 // cardinality
	  , 6
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"RQART_Driver2"
	  , (const char *)0
	  , &RQARTStructureProtocol::Base::rt_class
	  , RTOffsetOf( RQARTTestHarnessTestRun_VVIG_Actor, RQARTTestHarnessTestRun_VVIG_Actor::RQART_Driver2 )
	  , 1 // cardinality
	  , 7
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"RQART_Driver3"
	  , (const char *)0
	  , &RQARTStructureProtocol::Base::rt_class
	  , RTOffsetOf( RQARTTestHarnessTestRun_VVIG_Actor, RQARTTestHarnessTestRun_VVIG_Actor::RQART_Driver3 )
	  , 1 // cardinality
	  , 8
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"RQART_Driver4"
	  , (const char *)0
	  , &RQARTStructureProtocol::Base::rt_class
	  , RTOffsetOf( RQARTTestHarnessTestRun_VVIG_Actor, RQARTTestHarnessTestRun_VVIG_Actor::RQART_Driver4 )
	  , 1 // cardinality
	  , 9
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
