// {{{RME classifier 'Logical View::RQART_TestRun_VVIG::RQARTTestHarnessTestRun_VVIG'

#ifndef RQARTTestHarnessTestRun_VVIG_H
#define RQARTTestHarnessTestRun_VVIG_H

#ifdef PRAGMA
#pragma interface "RQARTTestHarnessTestRun_VVIG.h"
#endif

#include <RTSystem/VVIG.h>
#include <RQARTAbstractTestHarness.h>
#include <RQARTStructureProtocol.h>
enum RQARTExceptionCode;
class RQARTIncarnateArguments;
class RQARTStartTestNData;
extern const RTActorClass RQARTcap_VVIGimage_ClassifierW;
extern const RTActorClass RQARTcap_VVIGimage_ControllerW;
extern const RTActorClass RQARTcap_VVIGimage_DeviceW;
extern const RTActorClass RQARTcap_VVIGimage_ProcessorW;

// {{{RME tool 'OT::Cpp' property 'HeaderPreface'
// {{{USR

// }}}USR
// }}}RME

extern const RTActorClass RQARTTestHarnessTestRun_VVIG;

#define SUPER RQARTAbstractTestHarness_Actor
class RQARTTestHarnessTestRun_VVIG_Actor : public RQARTAbstractTestHarness_Actor
{
public:
	// {{{RME tool 'OT::Cpp' property 'PublicDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME tool 'OT::Cpp' property 'ProtectedDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

private:
	// {{{RME tool 'OT::Cpp' property 'PrivateDeclarations'
	// {{{USR

	// }}}USR
	// }}}RME

protected:
	// {{{RME capsuleRole 'image_Classifier'
	RTActorRef image_Classifier;
	// }}}RME
	// {{{RME capsuleRole 'image_Controller'
	RTActorRef image_Controller;
	// }}}RME
	// {{{RME capsuleRole 'image_Device'
	RTActorRef image_Device;
	// }}}RME
	// {{{RME capsuleRole 'image_Processor'
	RTActorRef image_Processor;
	// }}}RME
	// {{{RME port 'RQART_Driver1'
	RQARTStructureProtocol::Base RQART_Driver1;
	// }}}RME
	// {{{RME port 'RQART_Driver2'
	RQARTStructureProtocol::Base RQART_Driver2;
	// }}}RME
	// {{{RME port 'RQART_Driver3'
	RQARTStructureProtocol::Base RQART_Driver3;
	// }}}RME
	// {{{RME port 'RQART_Driver4'
	RQARTStructureProtocol::Base RQART_Driver4;
	// }}}RME

public:
	RQARTTestHarnessTestRun_VVIG_Actor( RTController * rtg_rts, RTActorRef * rtg_ref );
	virtual ~RQARTTestHarnessTestRun_VVIG_Actor( void );

protected:
	// {{{RME operation 'Test1Initialize(const int *const)'
	virtual void Test1Initialize( const int * const minRunTimes );
	// }}}RME
	// {{{RME operation 'Test1Complete()'
	virtual void Test1Complete( void );
	// }}}RME
	// {{{RME operation 'Test1CleanUp()'
	virtual void Test1CleanUp( void );
	// }}}RME
	// {{{RME operation 'InitializeTest(const int *const)'
	virtual void InitializeTest( const int * const minRunTimes );
	// }}}RME
	// {{{RME operation 'CompleteTest()'
	virtual void CompleteTest( void );
	// }}}RME
	// {{{RME operation 'CleanUpTest()'
	virtual void CleanUpTest( void );
	// }}}RME
	// {{{RME operation 'DestroyDrivers()'
	virtual void DestroyDrivers( void );
	// }}}RME
	// {{{RME operation 'DestroyCUTs()'
	virtual void DestroyCUTs( void );
	// }}}RME

public:
	virtual int _followOutV( RTBindingEnd & rtg_end, int rtg_compId, int rtg_portId, int rtg_repIndex );

protected:
	// {{{RME transition ':TOP:Initial:Initial'
	INLINE_METHODS void transition1_Initial( const void * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:AreAllDriversCompleted:True'
	INLINE_METHODS void transition11_True( const void * rtdata, RTProtocol * rtport );
	// }}}RME
	// {{{RME transition ':TOP:J4367A9A2001D:Incarnate_image_Controller'
	INLINE_METHODS void transition16_Incarnate_image_Controller( const void * rtdata, RQARTStructureProtocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:J4367A9A20038:Destroy_image_Controller'
	INLINE_METHODS void transition17_Destroy_image_Controller( const int * rtdata, RQARTStructureProtocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:J4367A9A20057:Incarnate_image_Device'
	INLINE_METHODS void transition18_Incarnate_image_Device( const void * rtdata, RQARTStructureProtocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:J4367A9A20074:Destroy_image_Device'
	INLINE_METHODS void transition19_Destroy_image_Device( const int * rtdata, RQARTStructureProtocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:J4367A9A20094:Incarnate_image_Processor'
	INLINE_METHODS void transition20_Incarnate_image_Processor( const void * rtdata, RQARTStructureProtocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:J4367A9A200B6:Destroy_image_Processor'
	INLINE_METHODS void transition21_Destroy_image_Processor( const int * rtdata, RQARTStructureProtocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:J4367A9A200DA:Incarnate_image_Classifier'
	INLINE_METHODS void transition22_Incarnate_image_Classifier( const void * rtdata, RQARTStructureProtocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:J4367A9A200FA:Destroy_image_Classifier'
	INLINE_METHODS void transition23_Destroy_image_Classifier( const int * rtdata, RQARTStructureProtocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:J4367A9A20124:LogMessage'
	INLINE_METHODS void transition24_LogMessage( const RTString * rtdata, RQARTStructureProtocol::Base * rtport );
	// }}}RME
	// {{{RME transition ':TOP:J4367A9A20148:CompareFailure'
	INLINE_METHODS void transition25_CompareFailure( const RTString * rtdata, RQARTStructureProtocol::Base * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain1_Initial( void );
	INLINE_CHAINS void chain12_errorException( void );
	INLINE_CHAINS void chain2_timeout( void );
	INLINE_CHAINS void chain6_timerCompleted( void );
	INLINE_CHAINS void chain24_LogMessage( void );
	INLINE_CHAINS void chain13_DriverFailed( void );
	INLINE_CHAINS void chain25_CompareFailure( void );
	INLINE_CHAINS void chain16_Incarnate_image_Controller( void );
	INLINE_CHAINS void chain17_Destroy_image_Controller( void );
	INLINE_CHAINS void chain18_Incarnate_image_Device( void );
	INLINE_CHAINS void chain19_Destroy_image_Device( void );
	INLINE_CHAINS void chain20_Incarnate_image_Processor( void );
	INLINE_CHAINS void chain21_Destroy_image_Processor( void );
	INLINE_CHAINS void chain22_Incarnate_image_Classifier( void );
	INLINE_CHAINS void chain23_Destroy_image_Classifier( void );
	INLINE_CHAINS void chain8_StartTest( void );
	INLINE_CHAINS void chain3_Reset( void );
	INLINE_CHAINS void chain4_SetMaxTime( void );
	INLINE_CHAINS void chain14_SetControllerVersion( void );
	INLINE_CHAINS void chain7_cleanUp( void );
	INLINE_CHAINS void chain5_timerCompleted( void );

protected:
	// {{{RME choicePoint ':TOP:AreAllDriversCompleted'
	INLINE_METHODS int choicePoint1_AreAllDriversCompleted( const void * rtdata, RTProtocol * rtport );
	// }}}RME

private:
	INLINE_CHAINS void chain11_True( void );
	INLINE_CHAINS void chain10_False( void );
	INLINE_CHAINS void chain9_DriverCompleted( void );
	INLINE_CHAINS void chain15_ignoreMessages( void );

public:
	virtual void rtsBehavior( int signalIndex, int portIndex );
	virtual const RTActor_class * getActorData( void ) const;

protected:
	static const RTActor_class rtg_class;

public:
	static const RTStateId rtg_parent_state[];

private:
	static const RTComponentDescriptor rtg_capsule_roles[];
	static const RTPortDescriptor rtg_ports[];
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'HeaderEnding'
// {{{USR

// }}}USR
// }}}RME

#endif /* RQARTTestHarnessTestRun_VVIG_H */

// }}}RME
