// {{{RME classifier 'Logical View::RQART_TestRun_VVIG::RQARTcap_VVIGimage_ClassifierWS'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "RQARTcap_VVIGimage_ClassifierWS.h"
#endif

#include <RTSystem/VVIG.h>
#include <RQARTcap_VVIGimage_ClassifierWS.h>

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"RQART_TestHarness"
	  , &RQARTStructureProtocol::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"to_controller"
	  , &Image_Classifier_Protocol::Conjugate::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_RQARTcap_VVIGimage_ClassifierWS_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new RQARTcap_VVIGimage_ClassifierWS_Actor( _rts, _ref );
}

const RTActorClass RQARTcap_VVIGimage_ClassifierWS =
{
	&RQARTAbstractTestWrapper
  , "RQARTcap_VVIGimage_ClassifierWS"
  , (RTVersionId)0
  , 2
  , rtg_relays
  , new_RQARTcap_VVIGimage_ClassifierWS_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "Failed"
  , "WaitingToStart"
  , "WaitingForTimer"
  , "IsMinRunTimeComplete"
};

#define SUPER RQARTAbstractTestWrapper_Actor

RQARTcap_VVIGimage_ClassifierWS_Actor::RQARTcap_VVIGimage_ClassifierWS_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RQARTAbstractTestWrapper_Actor( rtg_rts, rtg_ref )
	, RQART_TestHarness( (RQARTStructureProtocol::Conjugate &)RQARTAbstractTestWrapper_Actor::RQART_TestHarness )
{
}

RQARTcap_VVIGimage_ClassifierWS_Actor::~RQARTcap_VVIGimage_ClassifierWS_Actor( void )
{
}

int RQARTcap_VVIGimage_ClassifierWS_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// RQART_TestHarness
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &RQART_TestHarness;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	case 1:
		// to_controller
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &to_controller;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	default:
		break;
	}
	return RQARTAbstractTestWrapper_Actor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

INLINE_CHAINS void RQARTcap_VVIGimage_ClassifierWS_Actor::chain2_Initial( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 3 );
}

INLINE_CHAINS void RQARTcap_VVIGimage_ClassifierWS_Actor::chain1_errorException( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' transition ':TOP:Junction1:errorException'
	rtgChainBegin( 1, "errorException" );
	exitToChainState( 1, rtg_parent_state );
	rtgTransitionBegin();
	transition1_errorException( msg->data, (Exception::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void RQARTcap_VVIGimage_ClassifierWS_Actor::chain7_ignoreStartTestN( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' transition ':TOP:Junction4:ignoreStartTestN'
	rtgChainBegin( 1, "ignoreStartTestN" );
	rtgTransitionBegin();
	transition7_ignoreStartTestN( (const RQARTStartTestNData *)msg->data, (RQARTTestDriverProtocol::Conjugate *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTcap_VVIGimage_ClassifierWS_Actor::chain3_minRunTimeCompleted( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' transition ':TOP:Junction2:minRunTimeCompleted'
	rtgChainBegin( 1, "minRunTimeCompleted" );
	rtgTransitionBegin();
	transition3_minRunTimeCompleted( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTcap_VVIGimage_ClassifierWS_Actor::chain8_ignoreMessages( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' transition ':TOP:Failed:Junction2:ignoreMessages'
	rtgChainBegin( 2, "ignoreMessages" );
	rtgTransitionBegin();
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTcap_VVIGimage_ClassifierWS_Actor::chain5_minRunTimeCompleted( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' transition ':TOP:WaitingForTimer:Junction3:minRunTimeCompleted'
	rtgChainBegin( 4, "minRunTimeCompleted" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition5_minRunTimeCompleted( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 3 );
}

void RQARTcap_VVIGimage_ClassifierWS_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain2_Initial();
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestBase' port 'RQART_Exception'
				switch( signalIndex )
				{
				case Exception::Base::rti_error:
					chain1_errorException();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			case 4:
				// {{{RME classifier 'Logical View::RQART_TestRun_VVIG::RQARTcap_VVIGimage_ClassifierWS' port 'RQART_TestHarness'
				switch( signalIndex )
				{
				case RQARTStructureProtocol::Conjugate::rti_StartTestN:
					chain7_ignoreStartTestN();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			case 5:
				// {{{RME port 'RQART_Timer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					chain3_minRunTimeCompleted();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' state ':TOP:Failed'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestBase' port 'RQART_Exception'
				chain8_ignoreMessages();
				return;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 3:
			// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' state ':TOP:WaitingToStart'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			break;
			// }}}RME
		case 4:
			// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' state ':TOP:WaitingForTimer'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 5:
				// {{{RME port 'RQART_Timer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					chain5_minRunTimeCompleted();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * RQARTcap_VVIGimage_ClassifierWS_Actor::getActorData( void ) const
{
	return &RQARTcap_VVIGimage_ClassifierWS_Actor::rtg_class;
}

const RTActor_class RQARTcap_VVIGimage_ClassifierWS_Actor::rtg_class =
{
	&RQARTAbstractTestWrapper_Actor::rtg_class
  , rtg_state_names
  , 4
  , RQARTcap_VVIGimage_ClassifierWS_Actor::rtg_parent_state
  , &RQARTcap_VVIGimage_ClassifierWS
  , 0
  , (const RTComponentDescriptor *)0
  , 6
  , RQARTcap_VVIGimage_ClassifierWS_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId RQARTcap_VVIGimage_ClassifierWS_Actor::rtg_parent_state[] =
{
	0
  , 1
  , 1
  , 1
};

const RTPortDescriptor RQARTcap_VVIGimage_ClassifierWS_Actor::rtg_ports[] =
{
	{
		"RQART_Exception"
	  , (const char *)0
	  , &Exception::Base::rt_class
	  , RTOffsetOf( RQARTcap_VVIGimage_ClassifierWS_Actor, RQARTAbstractTestBase_Actor::RQART_Exception )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"RQART_Frame"
	  , (const char *)0
	  , &Frame::Base::rt_class
	  , RTOffsetOf( RQARTcap_VVIGimage_ClassifierWS_Actor, RQARTAbstractTestBase_Actor::RQART_Frame )
	  , 0 // excluded
	  , 2
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"RQART_Log"
	  , (const char *)0
	  , &Log::Base::rt_class
	  , RTOffsetOf( RQARTcap_VVIGimage_ClassifierWS_Actor, RQARTAbstractTestBase_Actor::RQART_Log )
	  , 1 // cardinality
	  , 3
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"RQART_TestHarness"
	  , (const char *)0
	  , &RQARTStructureProtocol::Conjugate::rt_class
	  , RTOffsetOf( RQARTcap_VVIGimage_ClassifierWS_Actor, RQARTAbstractTestWrapper_Actor::RQART_TestHarness )
	  , 1 // cardinality
	  , 4
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"RQART_Timer"
	  , (const char *)0
	  , &Timing::Base::rt_class
	  , RTOffsetOf( RQARTcap_VVIGimage_ClassifierWS_Actor, RQARTAbstractTestWrapper_Actor::RQART_Timer )
	  , 1 // cardinality
	  , 5
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"to_controller"
	  , (const char *)0
	  , &Image_Classifier_Protocol::Conjugate::rt_class
	  , RTOffsetOf( RQARTcap_VVIGimage_ClassifierWS_Actor, RQARTcap_VVIGimage_ClassifierWS_Actor::to_controller )
	  , 1 // cardinality
	  , 6
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
};

#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
