// {{{RME classifier 'Logical View::RQART_TestRun_VVIG::RQARTcap_VVIGimage_ControllerW'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "RQARTcap_VVIGimage_ControllerW.h"
#endif

#include <RTSystem/VVIG.h>
#include <RQARTcap_VVIGimage_ControllerW.h>

// {{{RME tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR

// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"RQART_TestHarness"
	  , &RQARTStructureProtocol::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"to_intbus"
	  , &P_VBAD::Conjugate::rt_class
	  , 1 // cardinality
	}
  , {
		"to_Image_Device"
	  , &Image_Device_Protocol::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"to_Image_Processor"
	  , &Image_Processor_Protocol::Base::rt_class
	  , 1 // cardinality
	}
  , {
		"to_Image_Classifier"
	  , &Image_Classifier_Protocol::Base::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_RQARTcap_VVIGimage_ControllerW_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new RQARTcap_VVIGimage_ControllerW_Actor( _rts, _ref );
}

const RTActorClass RQARTcap_VVIGimage_ControllerW =
{
	&RQARTcap_VVIGimage_ControllerWS
  , "RQARTcap_VVIGimage_ControllerW"
  , (RTVersionId)0
  , 5
  , rtg_relays
  , new_RQARTcap_VVIGimage_ControllerW_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
  , "Failed"
  , "WaitingToStart"
  , "WaitingForTimer"
  , "Test1_0"
  , "S1"
  , "S2"
  , "S3"
  , "IsMinRunTimeComplete"
};

#define SUPER RQARTcap_VVIGimage_ControllerWS_Actor

RQARTcap_VVIGimage_ControllerW_Actor::RQARTcap_VVIGimage_ControllerW_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RQARTcap_VVIGimage_ControllerWS_Actor( rtg_rts, rtg_ref )
{
}

RQARTcap_VVIGimage_ControllerW_Actor::~RQARTcap_VVIGimage_ControllerW_Actor( void )
{
}

int RQARTcap_VVIGimage_ControllerW_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// RQART_TestHarness
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &RQART_TestHarness;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	case 1:
		// to_intbus
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &to_intbus;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	case 2:
		// to_Image_Device
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &to_Image_Device;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	case 3:
		// to_Image_Processor
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &to_Image_Processor;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	case 4:
		// to_Image_Classifier
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &to_Image_Classifier;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	default:
		break;
	}
	return RQARTcap_VVIGimage_ControllerWS_Actor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

// {{{RME transition ':TOP:WaitingToStart:J4367A9A00222:Test1_0' guard '1'
#define SUPERMETHOD RQARTcap_VVIGimage_ControllerWS_Actor::guard9_Test1_0_event1
#define CALLSUPER RQARTcap_VVIGimage_ControllerWS_Actor::guard9_Test1_0_event1( rtdata, rtport )
INLINE_METHODS int RQARTcap_VVIGimage_ControllerW_Actor::guard9_Test1_0_event1( const RQARTStartTestNData * rtdata, RQARTStructureProtocol::Conjugate * rtport )
{
	// {{{USR
	return (rtdata->nCurrentTest == 1 && rtdata->nCardinalityIndex == 0);
	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:Test1_0:J4367A9A00232:StartTest'
#define SUPERMETHOD RQARTcap_VVIGimage_ControllerWS_Actor::transition11_StartTest
#define CALLSUPER RQARTcap_VVIGimage_ControllerWS_Actor::transition11_StartTest( rtdata, rtport )
INLINE_METHODS void RQARTcap_VVIGimage_ControllerW_Actor::transition11_StartTest( const RQARTStartTestNData * rtdata, RQARTStructureProtocol::Conjugate * rtport )
{
	// {{{USR
	nInstanceIndex = 2;

	StartMinRunTimeTimer(rtdata->nMinRunTime);
	to_Image_Device.take_photo().sendAt(0, General);
	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:Test1_0:S1:J4367A9A00290:photo_ready'
#define SUPERMETHOD RQARTcap_VVIGimage_ControllerWS_Actor::transition12_photo_ready
#define CALLSUPER RQARTcap_VVIGimage_ControllerWS_Actor::transition12_photo_ready( rtdata, rtport )
INLINE_METHODS void RQARTcap_VVIGimage_ControllerW_Actor::transition12_photo_ready( const void * rtdata, Image_Device_Protocol::Base * rtport )
{
	// {{{USR
	to_Image_Processor.Process_Image().sendAt(0, General);
	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

// {{{RME transition ':TOP:Test1_0:S2:J4367A9A002B2:Image_Processed'
#define SUPERMETHOD RQARTcap_VVIGimage_ControllerWS_Actor::transition13_Image_Processed
#define CALLSUPER RQARTcap_VVIGimage_ControllerWS_Actor::transition13_Image_Processed( rtdata, rtport )
INLINE_METHODS void RQARTcap_VVIGimage_ControllerW_Actor::transition13_Image_Processed( const void * rtdata, Image_Processor_Protocol::Base * rtport )
{
	// {{{USR
	to_Image_Classifier.Classify_Image().sendAt(0, General);
	// }}}USR
}
#undef SUPERMETHOD
#undef CALLSUPER
// }}}RME

INLINE_CHAINS void RQARTcap_VVIGimage_ControllerW_Actor::chain2_Initial( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' transition ':TOP:Initial:Initial'
	rtgChainBegin( 1, "Initial" );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 3 );
}

INLINE_CHAINS void RQARTcap_VVIGimage_ControllerW_Actor::chain1_errorException( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' transition ':TOP:Junction1:errorException'
	rtgChainBegin( 1, "errorException" );
	exitToChainState( 1, rtg_parent_state );
	rtgTransitionBegin();
	transition1_errorException( msg->data, (Exception::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 2 );
}

INLINE_CHAINS void RQARTcap_VVIGimage_ControllerW_Actor::chain7_ignoreStartTestN( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' transition ':TOP:Junction4:ignoreStartTestN'
	rtgChainBegin( 1, "ignoreStartTestN" );
	rtgTransitionBegin();
	transition7_ignoreStartTestN( (const RQARTStartTestNData *)msg->data, (RQARTTestDriverProtocol::Conjugate *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTcap_VVIGimage_ControllerW_Actor::chain3_minRunTimeCompleted( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' transition ':TOP:Junction2:minRunTimeCompleted'
	rtgChainBegin( 1, "minRunTimeCompleted" );
	rtgTransitionBegin();
	transition3_minRunTimeCompleted( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTcap_VVIGimage_ControllerW_Actor::chain8_ignoreMessages( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' transition ':TOP:Failed:Junction2:ignoreMessages'
	rtgChainBegin( 2, "ignoreMessages" );
	rtgTransitionBegin();
	rtgTransitionEnd();
}

INLINE_CHAINS void RQARTcap_VVIGimage_ControllerW_Actor::chain9_Test1_0( void )
{
	// transition ':TOP:WaitingToStart:J4367A9A00222:Test1_0'
	rtgChainBegin( 3, "Test1_0" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 5 );
	// transition ':TOP:Test1_0:J4367A9A00232:StartTest'
	rtgChainBegin( 5, "StartTest" );
	rtgTransitionBegin();
	transition11_StartTest( (const RQARTStartTestNData *)msg->data, (RQARTStructureProtocol::Conjugate *)msg->sap() );
	rtgTransitionEnd();
	enterState( 6 );
}

INLINE_CHAINS void RQARTcap_VVIGimage_ControllerW_Actor::chain5_minRunTimeCompleted( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' transition ':TOP:WaitingForTimer:Junction3:minRunTimeCompleted'
	rtgChainBegin( 4, "minRunTimeCompleted" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition5_minRunTimeCompleted( msg->data, (Timing::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 3 );
}

INLINE_CHAINS void RQARTcap_VVIGimage_ControllerW_Actor::chain12_photo_ready( void )
{
	// transition ':TOP:Test1_0:S1:J4367A9A00290:photo_ready'
	rtgChainBegin( 6, "photo_ready" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition12_photo_ready( msg->data, (Image_Device_Protocol::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 7 );
}

INLINE_CHAINS void RQARTcap_VVIGimage_ControllerW_Actor::chain13_Image_Processed( void )
{
	// transition ':TOP:Test1_0:S2:J4367A9A002B2:Image_Processed'
	rtgChainBegin( 7, "Image_Processed" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	transition13_Image_Processed( msg->data, (Image_Processor_Protocol::Base *)msg->sap() );
	rtgTransitionEnd();
	enterState( 8 );
}

INLINE_CHAINS void RQARTcap_VVIGimage_ControllerW_Actor::chain14_Image_Classified( void )
{
	// transition ':TOP:Test1_0:S3:J4367A9A002DE:Image_Classified'
	rtgChainBegin( 8, "Image_Classified" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	rtgTransitionEnd();
	// transition ':TOP:Test1_0:J4367A9A00246:Test1_0'
	rtgChainBegin( 5, "Test1_0" );
	exitState( rtg_parent_state );
	rtgTransitionBegin();
	rtgTransitionEnd();
	if( choicePoint1_IsMinRunTimeComplete( msg->data, msg->sap() ) )
		chain6_True();
	else
		chain4_False();
}

INLINE_CHAINS void RQARTcap_VVIGimage_ControllerW_Actor::chain6_True( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' transition ':TOP:IsMinRunTimeComplete:True'
	rtgChainBegin( 9, "True" );
	rtgTransitionBegin();
	transition6_True( msg->data, msg->sap() );
	rtgTransitionEnd();
	enterState( 3 );
}

INLINE_CHAINS void RQARTcap_VVIGimage_ControllerW_Actor::chain4_False( void )
{
	// classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' transition ':TOP:IsMinRunTimeComplete:False'
	rtgChainBegin( 9, "False" );
	rtgTransitionBegin();
	rtgTransitionEnd();
	enterState( 4 );
}

void RQARTcap_VVIGimage_ControllerW_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					chain2_Initial();
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestBase' port 'RQART_Exception'
				switch( signalIndex )
				{
				case Exception::Base::rti_error:
					chain1_errorException();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			case 4:
				// {{{RME classifier 'Logical View::RQART_TestRun_VVIG::RQARTcap_VVIGimage_ControllerWS' port 'RQART_TestHarness'
				switch( signalIndex )
				{
				case RQARTStructureProtocol::Conjugate::rti_StartTestN:
					chain7_ignoreStartTestN();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			case 5:
				// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' port 'RQART_Timer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					chain3_minRunTimeCompleted();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		case 2:
			// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' state ':TOP:Failed'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 1:
				// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestBase' port 'RQART_Exception'
				chain8_ignoreMessages();
				return;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 3:
			// {{{RME state ':TOP:WaitingToStart'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 4:
				// {{{RME classifier 'Logical View::RQART_TestRun_VVIG::RQARTcap_VVIGimage_ControllerWS' port 'RQART_TestHarness'
				switch( signalIndex )
				{
				case RQARTStructureProtocol::Conjugate::rti_StartTestN:
					if( guard9_Test1_0_event1( (const RQARTStartTestNData *)msg->data, (RQARTStructureProtocol::Conjugate *)msg->sap() ) )
					{
						chain9_Test1_0();
						return;
					}
					break;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 4:
			// {{{RME classifier 'Logical View::RQARTClasses::CPP::V6_4_100_0::RQARTAbstractTestWrapper' state ':TOP:WaitingForTimer'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 5:
				// {{{RME port 'RQART_Timer'
				switch( signalIndex )
				{
				case Timing::Base::rti_timeout:
					chain5_minRunTimeCompleted();
					return;
				default:
					break;
				}
				break;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 5:
			// {{{RME state ':TOP:Test1_0'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			break;
			// }}}RME
		case 6:
			// {{{RME state ':TOP:Test1_0:S1'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 7:
				// {{{RME classifier 'Logical View::RQART_TestRun_VVIG::RQARTcap_VVIGimage_ControllerWS' port 'to_Image_Device'
				chain12_photo_ready();
				return;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 7:
			// {{{RME state ':TOP:Test1_0:S2'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 8:
				// {{{RME classifier 'Logical View::RQART_TestRun_VVIG::RQARTcap_VVIGimage_ControllerWS' port 'to_Image_Processor'
				chain13_Image_Processed();
				return;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		case 8:
			// {{{RME state ':TOP:Test1_0:S3'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			case 9:
				// {{{RME classifier 'Logical View::RQART_TestRun_VVIG::RQARTcap_VVIGimage_ControllerWS' port 'to_Image_Classifier'
				chain14_Image_Classified();
				return;
				// }}}RME
			default:
				break;
			}
			break;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * RQARTcap_VVIGimage_ControllerW_Actor::getActorData( void ) const
{
	return &RQARTcap_VVIGimage_ControllerW_Actor::rtg_class;
}

const RTActor_class RQARTcap_VVIGimage_ControllerW_Actor::rtg_class =
{
	&RQARTcap_VVIGimage_ControllerWS_Actor::rtg_class
  , rtg_state_names
  , 8
  , RQARTcap_VVIGimage_ControllerW_Actor::rtg_parent_state
  , &RQARTcap_VVIGimage_ControllerW
  , 0
  , (const RTComponentDescriptor *)0
  , 9
  , RQARTcap_VVIGimage_ControllerW_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 0
  , (const RTFieldDescriptor *)0
};

const RTStateId RQARTcap_VVIGimage_ControllerW_Actor::rtg_parent_state[] =
{
	0
  , 1
  , 1
  , 1
  , 1
  , 5
  , 5
  , 5
};

const RTPortDescriptor RQARTcap_VVIGimage_ControllerW_Actor::rtg_ports[] =
{
	{
		"RQART_Exception"
	  , (const char *)0
	  , &Exception::Base::rt_class
	  , RTOffsetOf( RQARTcap_VVIGimage_ControllerW_Actor, RQARTAbstractTestBase_Actor::RQART_Exception )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"RQART_Frame"
	  , (const char *)0
	  , &Frame::Base::rt_class
	  , RTOffsetOf( RQARTcap_VVIGimage_ControllerW_Actor, RQARTAbstractTestBase_Actor::RQART_Frame )
	  , 0 // excluded
	  , 2
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"RQART_Log"
	  , (const char *)0
	  , &Log::Base::rt_class
	  , RTOffsetOf( RQARTcap_VVIGimage_ControllerW_Actor, RQARTAbstractTestBase_Actor::RQART_Log )
	  , 1 // cardinality
	  , 3
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"RQART_TestHarness"
	  , (const char *)0
	  , &RQARTStructureProtocol::Conjugate::rt_class
	  , RTOffsetOf( RQARTcap_VVIGimage_ControllerW_Actor, RQARTAbstractTestWrapper_Actor::RQART_TestHarness )
	  , 1 // cardinality
	  , 4
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"RQART_Timer"
	  , (const char *)0
	  , &Timing::Base::rt_class
	  , RTOffsetOf( RQARTcap_VVIGimage_ControllerW_Actor, RQARTAbstractTestWrapper_Actor::RQART_Timer )
	  , 1 // cardinality
	  , 5
	  , RTPortDescriptor::KindSpecial + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityProtected
	}
  , {
		"to_intbus"
	  , (const char *)0
	  , &P_VBAD::Conjugate::rt_class
	  , RTOffsetOf( RQARTcap_VVIGimage_ControllerW_Actor, RQARTcap_VVIGimage_ControllerWS_Actor::to_intbus )
	  , 1 // cardinality
	  , 6
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"to_Image_Device"
	  , (const char *)0
	  , &Image_Device_Protocol::Base::rt_class
	  , RTOffsetOf( RQARTcap_VVIGimage_ControllerW_Actor, RQARTcap_VVIGimage_ControllerWS_Actor::to_Image_Device )
	  , 1 // cardinality
	  , 7
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"to_Image_Processor"
	  , (const char *)0
	  , &Image_Processor_Protocol::Base::rt_class
	  , RTOffsetOf( RQARTcap_VVIGimage_ControllerW_Actor, RQARTcap_VVIGimage_ControllerWS_Actor::to_Image_Processor )
	  , 1 // cardinality
	  , 8
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
  , {
		"to_Image_Classifier"
	  , (const char *)0
	  , &Image_Classifier_Protocol::Base::rt_class
	  , RTOffsetOf( RQARTcap_VVIGimage_ControllerW_Actor, RQARTcap_VVIGimage_ControllerWS_Actor::to_Image_Classifier )
	  , 1 // cardinality
	  , 9
	  , RTPortDescriptor::KindWired + RTPortDescriptor::NotificationDisabled + RTPortDescriptor::RegisterNotPermitted + RTPortDescriptor::VisibilityPublic
	}
};
#undef SUPER

// {{{RME tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR

// }}}USR
// }}}RME

// }}}RME
